// FTPSetting 부분 플러그인이다.
#ifndef FTPSETPLUGIN_H
#define FTPSETPLUGIN_H

#include "../HeaderFile/ConsDefine.h" 
#include "../HeaderFile/wftpinterface.h"
#include "../HeaderFile/ReMakeInstance.h"
#include "../HeaderFile/mylineedit.h" // 라인에디트 클릭시 키패드가 나타나도록 수정한 라인에디트

//Up server
#include "../client/client_handler.h"
#include "../client/ftpclient.h"
#include "./ServerLogText.h"

class ReSizeListWidget;
class MyLineEdit;
class NewPushButton;
class Handler;

//Up server
class FtpServer;
class LogTextEdit : public QObject
{
	Q_OBJECT
	public :
		int LogText(QTextEdit *Edit);
};
//----
//D

struct Dir_Info
{
	char file_permission[256];
	char a[5];
	char user1[127];
	char user2[127];
	char file_size[256];
	char date1[100];
	char date2[100];
	char date3[100];
	char file_name[256];
};

class FTPSetPlugin : public QObject, public FTPSetInterface
{
	Q_OBJECT
	Q_INTERFACES(FTPSetInterface)
	
	public slots:
		void Send_Dir(QString); // 디렉토리 검색 루틴에서 emit 하는 목록을 받아서 처리하기 위한 함수.
	public :
		QHash<QString,QString>Wasthechecked;
		Handler hn; // 디렉토리 검색을 위한 객체 선언.
		FTPSetPlugin();
		void FtpDo_Dir(QString SubFolderName,QTreeWidgetItem *SubDirItem); // ftp의 서브 디렉토리 검색
		QHash<QString,QString>PluginFtpFileInfo; // 파일 혹은 폴더인지를 저장하는 해시 테이블.
		QTreeWidgetItem* DirItem;
		QList<QTreeWidgetItem *> DirItems;
		QTreeWidget* DownDirTreeWidget; // 메인의 다운로드 트리 위젯.
		QTreeWidget* DirTreeWidget; 
		QList<QTreeWidgetItem *>DownDirItems;
		QTreeWidgetItem* DownDirItem;
		QTreeWidgetItem* SubDiretroyItem; 
		QTreeWidgetItem* DownSubDirItem; // 메인의 다운로드 서브 디렉토리를 위한 위젯 아이템 
		QTreeWidgetItem* UpSubDirItem;
		bool ThisIsSubDir; //  서브 디렉토리 중복 검색시 예외 처리
		void Calldir(QTreeWidget *treeWidget,QTreeWidget *downtreeWidget); // 메인에서 플러그인으로 Dir 함수 호출을 연계 해줌.
		QString CheckFtpFileInfo(QString);

		int StackLayoutValue;
		int ButtonLayoutValue;
		//Layout Return Function
		void ReSetLayoutSender(QStackedLayout *WidgetLayout);
		void SetButtonLayoutSender(QStackedLayout *ButtonLayout);
		//Widget Display
		int FTPSetButton(QVBoxLayout *LayoutSender, int value);	
		void SelectFTPClientOrServer(QStackedLayout *layout);
		void FTPClientConnect(QStackedLayout *layout);
		void FTPConnectPage(QStackedLayout *layout);
		//Button Widget
		int WClientOrServerButton(QStackedLayout *Buttonlayout, int Buttonvalue);
		void WClientButton(QStackedLayout *Buttonlayout);
		void FTPSettingButton(QStackedLayout *Buttonlayout);
		
		QVBoxLayout *LogLayout;
		public slots :
		void FTPSettingRecevie();	//When WFTPSetButton Click
		void FTPClientPage();		//When ClientButton Click
		void FTPSettingPage();
		void ConnectFTP();

		//CheckBox Click
		void CheckBoxEvent();
		
		//Move to Widget()
		void WFTPLinMain();
		void WFTPSetMain();
		void ConnectCancel();
		void ConnectState();
		void GotoFourthPage();
	private :
		QStackedLayout *ReSetLayout;
		QStackedLayout *SetButtonLayout;

		//FTPSetButton()
		NewPushButton *WFTPSetButton;

		//SelectFTPClientOrServer()
		QWidget *SixthWidget;
		QVBoxLayout *FTPSVBoxLayout;
		QLabel *FTPLabel;
		NewPushButton *ClientButton;
		NewPushButton *ServerButton;

		//FTPClientConnect()
		QWidget *FTPClientWidget;
		QVBoxLayout *FTPClientLayout;
		QLabel *FTPClientLabel;
		QGroupBox *FTPClientBox;
		QGridLayout *FTPCliAddress;
		QLabel *FTPAddress;
		//QLineEdit *FTPAddressEdit;
		QComboBox *AddressCombo;
		QGroupBox *FTPUserInfo;
		QGridLayout *FTPInfoGridLay;
		QLabel *FTPUserID;
		//QLineEdit *FTPUserIDLineEdit;
		MyLineEdit *FTPUserIDLineEdit;
		QLabel *FTPPW;
		//QLineEdit *FTPPWLineEdit;
		MyLineEdit *FTPPWLineEdit;
		QCheckBox *FTPCliCheck;

		//FTPConnectPage()
		QWidget *FTPLogServerWidget;
//		QVBoxLayout *LogLayout;
		LogTextEdit *edit;
		QTextEdit *ME;
		QLabel *FTPLogLabel;
		QLabel *UserLabel;
		ReSizeListWidget *listwidget;
		QListWidgetItem *item;

		//WClientOrServerButton()
		QWidget *WCliSerButtonWidget;
		QHBoxLayout *WCliSerHBoxLayout;
		QPushButton *WCliSerMain;
		QPushButton *WCliSerBackButton;

		//WClientButton()
		QWidget *WCliButtonWidget;
		QHBoxLayout *WCliHBoxLayout;
		QPushButton *WCliMain;
		QPushButton *WCliConnectButton;
		QPushButton *WCliCancelButton;
		int count;
		int ftpFlag;

		//FTPSettingButton()
		QWidget *FTPSetButtonWidget;
		QHBoxLayout *FTPSetHBoxLayout;
		QPushButton *FTPSetMain;
		QPushButton *FTPSetConnectButton;
		QPushButton *FTPSetCancelButton;
};					 
#endif
