#include "DirDialog.h"
#include <QModelIndex>
#include <QVBoxLayout>
#include <QHeaderView>
#include <QDialogButtonBox>
#include <QPushButton>
#include <QString>
DirDialog::DirDialog(QWidget *parent) : QDialog(parent)
{
	resize(250,320);	
	model = new QDirModel;
	model->setReadOnly(false);
	model->setSorting(QDir::DirsFirst | QDir::IgnoreCase | QDir::Name);

	QLabel *Label = new QLabel(kor("공유할 파일/폴더를 선택해 주세요."));
	
	treeView = new QTreeView;
	treeView->setModel(model);
	treeView->header()->setStretchLastSection(true);
	treeView->header()->setSortIndicator(0, Qt::AscendingOrder);
	treeView->header()->setSortIndicatorShown(true);
	treeView->header()->setClickable(true);
	treeView->setColumnHidden(1,true);	//디렉토리 Name만 보이게끔 나머지는 숨김
	treeView->setColumnHidden(2,true);
	treeView->setColumnHidden(3,true);

	QModelIndex index = model->index(QDir::currentPath());
	treeView->expand(index);
//	treeView->scrollTo(index);
	treeView->resizeColumnToContents(0);
	treeView->setRootIndex(model->index(QDir::cleanPath("/mnt")));

	
    QDialogButtonBox *buttonBox = new QDialogButtonBox(Qt::Horizontal);
    addButton = buttonBox->addButton(kor("추가"),QDialogButtonBox::ActionRole);
 	buttonBox->addButton(kor("취소"), QDialogButtonBox::AcceptRole);

    connect(addButton, SIGNAL(clicked()), this, SLOT(AddDir()));
	connect(addButton, SIGNAL(clicked()), this, SLOT(accept()));
	connect(buttonBox, SIGNAL(accepted()), this, SLOT(accept()));
	
	QVBoxLayout *mainLayout = new QVBoxLayout;
	mainLayout->addWidget(Label);
	mainLayout->addWidget(treeView);
	mainLayout->addWidget(buttonBox);
	setLayout(mainLayout);

	setWindowTitle(tr("Directory Viewer"));
}

void DirDialog::AddDir()
{
	qDebug("Add");
	QModelIndex index = treeView->currentIndex();

	Path = model->filePath(index);
	Name = model->fileName(index);
}

QString DirDialog::getName()
{
	return Name;
}
QString DirDialog::getPath()
{
	return Path;
}
