#include "FTPSettingPlugin.h"
#include <QSpinBox>
void FTPSettingPlugin::FTPSettingLayoutSender(QStackedLayout *WidgetLayout)
{
     ReSetLayout =   WidgetLayout;
}
void FTPSettingPlugin::FTPSettingButtonLayoutSender(QStackedLayout *ButtonLayout)
{
     SetButtonLayout = ButtonLayout;
}
int FTPSettingPlugin::FTPSettingButton(QVBoxLayout *LayoutSender, int value)
{
		FTPSettingLayoutValue = value;
		FTPSetting = new NewPushButton("FTP Server Setting");
	    LayoutSender->addWidget(FTPSetting);
        connect(FTPSetting, SIGNAL(clicked()), this, SLOT(FTPSettingPage()));
        LayoutSender->addStretch();

		return FTPSettingLayoutValue;
}

// Server 부분
void FTPSettingPlugin::FTPServerConnect(QStackedLayout *layout)
{
     FTPSettingLayoutSender(layout);
 
     FTPServerWidget = new QWidget;
     layout->addWidget(FTPServerWidget);
 
     FTPServerLayout = new QVBoxLayout(FTPServerWidget);
 
     FTPServerLabel = new QLabel("FTP Server");
     FTPServerLayout->addWidget(FTPServerLabel);
     FTPServerLabel->setFrameStyle(QFrame::Box | QFrame::Sunken);
     FTPServerLabel->setLineWidth(1);
     FTPServerLabel->setAlignment(Qt::AlignHCenter);
 
     SetAccount = new QGroupBox(kor("계정 설정"));
     FTPServerLayout->addWidget(SetAccount);
 
     AccountGridLay = new QGridLayout;
     SetAccount->setLayout(AccountGridLay);
 
     SAnonymity = new QCheckBox(kor("익명 연결"));
     AccountGridLay->addWidget(SAnonymity,2,0);
     connect(SAnonymity, SIGNAL(clicked()), this, SLOT(CheckBoxAnonymity()));

	 AutoConnect = new QCheckBox(kor("자동 연결"));
	 AccountGridLay->addWidget(AutoConnect,2,1);
     connect(AutoConnect, SIGNAL(clicked()), this, SLOT(AutoConnectFunc()));

     ID = new QLabel("User ID");
     AccountGridLay->addWidget(ID,0,0);
     IDEdit = new MyLineEdit;
     AccountGridLay->addWidget(IDEdit,0,1);
 
     Password = new QLabel("Password");
     AccountGridLay->addWidget(Password,1,0);
     PWEdit = new MyLineEdit;
     PWEdit->setEchoMode(QLineEdit::Password);
	 AccountGridLay->addWidget(PWEdit,1,1);

	 FTPServerLayout ->addStretch();
 
     DirectoryBox = new QGroupBox(kor("디렉토리 검색"));
     FTPServerLayout->addWidget(DirectoryBox);

	 DirGridLay = new QGridLayout;
     DirectoryBox->setLayout(DirGridLay);
	
/*	 QLabel *applyLabel = new QLabel(kor("허용 인원 : "));
	 DirGridLay->addWidget(applyLabel,0,0);

	 applyConnecter = new QSpinBox();
	 applyConnecter->setMaximum(5);
	 applyConnecter->setValue(5);
	 DirGridLay->addWidget(applyConnecter,0,1);
	 Connecter = 5;
	 connect(applyConnecter, SIGNAL(valueChanged(int)), this, SLOT(changedSpinBox(int)));
*/
     DirSearchView = new QTreeWidget();
     DirSearchView->setHeaderLabels(QStringList() << kor("공유파일") << kor("폴더경로"));
//	 DirSearchView->verticalHeader()->hide();
//	 DirSearchView->setShowGrid(false);
	 DirGridLay->addWidget(DirSearchView,0,0,2,2);
	 connect(DirSearchView, SIGNAL(itemClicked(QTreeWidgetItem *,int)), this, SLOT(itemValue(QTreeWidgetItem *)));

     DirAdd = new QPushButton(kor(" 추가"));
     DirAdd->setIcon(QIcon("./image/Desktop_Folder.png"));
	 DirAdd->setFocusPolicy(Qt::NoFocus);    //버튼 포커스 설정
	 DirAdd->setFlat(true);  //버튼 평면화
	 DirGridLay->addWidget(DirAdd,2,0);
	 connect(DirAdd, SIGNAL(clicked()), this, SLOT(DirSearch()));

	 Dirmi = new QPushButton(kor(" 삭제"));
	 Dirmi->setIcon(QIcon("./image/D1.png"));
	 Dirmi->setFocusPolicy(Qt::NoFocus);    //버튼 포커스 설정
	 Dirmi->setFlat(true);  //버튼 평면화
	 DirGridLay->addWidget(Dirmi,2,1);
	 connect(Dirmi, SIGNAL(clicked()), this, SLOT(DirDelect())); 
     FTPServerLayout->addStretch();
}
void FTPSettingPlugin::changedSpinBox(int value)
{
	Connecter = value;
	qDebug("%d",Connecter);	
}
void FTPSettingPlugin::itemValue(QTreeWidgetItem *)
{
	QModelIndex TreeWidgetIndex = DirSearchView->currentIndex();
	TreeIndex = TreeWidgetIndex.row();
	qDebug("%d",TreeIndex);
}
void FTPSettingPlugin::DirDelect()
{
	if(TreeIndex != -1)
	{
		DirSearchView->takeTopLevelItem(TreeIndex);
	}
}
void FTPSettingPlugin::DirSearch()
{
	DirDialog *Dira = new DirDialog();
	Dira->setStyleSheet("QWidget {background-color: beige;}"); 
	int n = Dira->exec();

	if(n==QDialog::Accepted)
	{
		QString strName = Dira->getName();
		QString strPath = Dira->getPath();
	
		item = new QTreeWidgetItem(DirSearchView);
		item->setText(0,strName);	
		item->setText(1,strPath);
	}
}
//Server 버튼
int FTPSettingPlugin::WServerButton(QStackedLayout *Buttonlayout, int value)
{
	FTPSetButtonLayoutValue = value;
	FTPSettingButtonLayoutSender(Buttonlayout);

	WSerButtonWidget = new QWidget;
	Buttonlayout->addWidget(WSerButtonWidget);


	WSerHBoxLayout = new QHBoxLayout(WSerButtonWidget);
	WSerHBoxLayout->setMargin(0);
	WSerHBoxLayout->setSpacing(0);

	WSerMain = new QPushButton(" Main");
	WSerHBoxLayout->addWidget(WSerMain);
	WSerMain->setFlat(true);  //버튼 평면화
	WSerMain->setIcon(QIcon("./image/Home.png"));
	WSerMain->setFocusPolicy(Qt::NoFocus);    //버튼
	connect(WSerMain, SIGNAL(clicked()), this, SLOT(WFTPLinMain()));

	WSerConnectButton = new QPushButton(kor(" 등록"));
	WSerConnectButton->setIcon(QIcon("./image/+.png"));
	WSerConnectButton->setFocusPolicy(Qt::NoFocus);    //버튼 포커스 설정
	WSerConnectButton->setFlat(true);  //버튼 평면화
	WSerHBoxLayout->addWidget(WSerConnectButton);
	connect(WSerConnectButton, SIGNAL(clicked()), this, SLOT(SetConnectWrite()));
	
	WSerCancelButton = new QPushButton(kor(" 취소"));
	WSerCancelButton->setIcon(QIcon("./image/Delete2.png"));
	WSerCancelButton->setFocusPolicy(Qt::NoFocus);    //버튼 포커스 설정
	WSerCancelButton->setFlat(true);  //버튼 평면화
	WSerHBoxLayout->addWidget(WSerCancelButton);
	connect(WSerCancelButton, SIGNAL(clicked()), this,SLOT(WFTPSetMain()));

	return FTPSetButtonLayoutValue;
}

void FTPSettingPlugin::CheckBoxAnonymity()
{
	if(SAnonymity->isChecked())
	{
		ID->setEnabled(false);
		IDEdit->setEnabled(false);
		Password->setEnabled(false);
		PWEdit->setEnabled(false);
	}
	else{
		ID->setEnabled(true);
		IDEdit->setEnabled(true);
		Password->setEnabled(true);
		PWEdit->setEnabled(true);
	}
}


void FTPSettingPlugin::AutoConnectFunc()
{
}
void FTPSettingPlugin::SetConnectWrite()
{
     QString str = IDEdit->text();
     QString PassWord = PWEdit->text();
	 QString FileName = item->text(0);
	 QString FilePath = item->text(1);
 	 
	 QFile file("/etc/denftpserver/userinfo.ini");
	 if(!file.open(QIODevice::WriteOnly))
	 {
	         qWarning("Couldn't Open");
	 }
     QTextStream ts(&file);
     ts << "user= "<< str << " " << PassWord << " " << "/" << " " << "5" << " " << "A" << endl;
	 ts << "FileName=" << FileName <<endl;
	 ts << "FilePath=" << FilePath <<endl;  

     file.close();
     WFTPSetMain();
}

 //Go to Main Widget();
 void FTPSettingPlugin::WFTPLinMain()
 {
       ReSetLayout->setCurrentIndex(MainFirstWidget);
       SetButtonLayout->setCurrentIndex(SetMainButton); //0
 }
 //go to Second Widget()
 void FTPSettingPlugin::WFTPSetMain()
 {
       ReSetLayout->setCurrentIndex(MainThridWidget);  //2
       SetButtonLayout->setCurrentIndex(SetMainButton); //0
 }
 //
void FTPSettingPlugin::FTPSettingPage()
{
     ReSetLayout->setCurrentIndex(FTPSettingLayoutValue);
     SetButtonLayout->setCurrentIndex(FTPSetButtonLayoutValue);
}
Q_EXPORT_PLUGIN2(FTPSettingPlugin, FTPSettingPlugin);


