#include <QPainter>
#include "numpad.h"

#ifndef QT_NO_SCREEN_KEYBOARD

#define CX_BUTTON 40
#define CY_BUTTON 30

NumPad::NumPad(QWidget* parent) :QDialog(parent)
{
    setWindowTitle("Key Borad");    
	setFixedSize(120,150);
	pm = new QPixmap("./number.png");

	clickcount = 0;	
    m_ChangeCount = 0;
	QFont font("unifont");
	this->setFont(font);

    for(int i = 0; i < 5; i++)
    {
	for(int j = 0; j<3 ; j++)
	{
	    m_numKey[i][j].setRect(CX_BUTTON * j, CY_BUTTON * i,CX_BUTTON,CY_BUTTON);
	    
	}
    }
    m_nKey[0] ="123";
    m_nKey[1] ="456";
    m_nKey[2] ="789";
    m_nKey[3] ="0.D";
	m_nKey[4] ="M-X";
    //화면에 디스플레이할 때 사용하는 대문자  집합
	m_alphaKey[0][0]=".QZ";
	m_alphaKey[0][1]="ABC";
	m_alphaKey[0][2]="DEF";
	m_alphaKey[1][0]="GHI";
	m_alphaKey[1][1]="JKL";
	m_alphaKey[1][2]="MNO";
	m_alphaKey[2][0]="PRS";
	m_alphaKey[2][1]="TUV";
	m_alphaKey[2][2]="WXY";
	m_alphaKey[3][0]="*";
	m_alphaKey[3][1]="=>";
	m_alphaKey[3][2]="#";

 	//화면에 디스플레이할 때 사용하는 소문자 집합 
	m_SmallalphaKey[0][0] =".qz";
	m_SmallalphaKey[0][1] ="abc";
	m_SmallalphaKey[0][2] ="def";
	m_SmallalphaKey[1][0] ="ghi";
	m_SmallalphaKey[1][1] ="jkl";
	m_SmallalphaKey[1][2] ="mno";
	m_SmallalphaKey[2][0] ="prs";
	m_SmallalphaKey[2][1] ="tuv";
	m_SmallalphaKey[2][2] ="wxy";
	m_SmallalphaKey[3][0] ="*";
	m_SmallalphaKey[3][1] ="=>";
	m_SmallalphaKey[3][2] ="#";


	//대문자 문자열 집합
	m_strKey[0]=".QZABCDEF";
	m_strKey[1]="GHIJKLMNO";
	m_strKey[2]="PRSTUVWXY";
	m_strKey[3]="*#"; 	
    //소문자 문자열 집합
	m_SmallstrKey[0]=".qzabcdef";
	m_SmallstrKey[1]="ghijklmno";
	m_SmallstrKey[2]="prstuvwxy";
	m_SmallstrKey[3]="*#";

    tempi = -1;
	tempj = -1;
	IsSetForwardKey = false;
	connect(this,SIGNAL(sigSelectKey(const QString&)), parent,SLOT(slotMyInsert(const QString&)));
}
void NumPad::paintEvent(QPaintEvent*)
{

    QPainter p(this);
    p.fillRect(0,0,width(),height(),QBrush(Qt::white));
    p.setPen(QPen(Qt::black,1,Qt::DotLine));
    p.drawRect(0,0,CX_BUTTON * 3 , CY_BUTTON * 5);

    for(int i = 0 ; i	<5 ; i ++ )
    {
	    for(int j = 0 ; j < 3; j++)
	    {
	            p.drawRect(m_numKey[i][j]);	
	          //p.drawText(m_numKey[i][j],Qt::AlignCenter,QString(m_nKey[i][j]));
	          if(m_ChangeCount == 0)
			  	p.drawText(m_numKey[i][j],Qt::AlignCenter,QString(m_alphaKey[i][j]));//대문자 출력
			  else if(m_ChangeCount == 1)
				p.drawText(m_numKey[i][j],Qt::AlignCenter,QString(m_SmallalphaKey[i][j]));//소문자 출력
			  else if(m_ChangeCount == 2)
				//p.drawPixmap(0,0,*pm);
				p.drawText(m_numKey[i][j],Qt::AlignCenter,QString(m_nKey[i][j]));//숫자 출력
		}
    }
}

//각각의 글자에 할당된 영역으로 터치 이벤트가 들어갔는지에 대해 검사한다음 해당 글자를 출력하여 준다. 
void NumPad::mousePressEvent(QMouseEvent* e)
{
    
    QPoint   point = e->pos();
    QPainter p(this);
    
    m_numSelectedKey = QRect(-1,-1,-1,-1);
    m_nSelectedKey = "";
    IsSetForwardKey = false;
    //루프를 돌면서 마우스 포인터가 찍힌 위치를 검사하여 해당하는 문자를 출력해 준다.   
	for (int i = 0 ; i <5 ; i++)
	{
		for(int j = 0 ; j < 3; j++)
		{
			if(m_numKey[i][j].contains(point))
			{	
				if(i == 4 && j == 0 )// 모드 변경, 영문대소문자,숫자 선택
				{
					m_ChangeCount++;
					clickcount = 0;
					if(m_ChangeCount == 3) m_ChangeCount = 0;
					repaint();
					break;
				}
				if( i == 4 && j == 2) // 키보드 종료 
				{
					qDebug("exit");
				}
				if(i == 3 && j == 2) // 입력 값 삭제
				{
					emit sigSelectKey(QString(QChar(0x08)));
					IsSetForwardKey = true;
					qDebug("del");
				}
				if(i == 4 && j == 1)
				{
					emit sigSelectKey(QString("left"));
					qDebug("left");
					IsSetForwardKey = true;
					clickcount = 0;
					break;
				}
			    if(m_ChangeCount == 0) // 대문자 입력
				{
						if(tempi != i || tempj != j)						
                        {
						   tempi = i;
					       tempj = j;	   
						   clickcount = 0;
						}
						if(clickcount > 0)
                          	emit sigSelectKey(QString(QChar(0x08)));
						  qDebug("set Key");
					      m_numSelectedKey = m_numKey[i][j];
						  m_nSelectedKey = m_strKey[i][(j*3)+(clickcount++)];
						  if(clickcount == 3) clickcount = 0;
						
				}
				else if(m_ChangeCount == 1) //소문자 입력
				{
					if(tempi != i || tempj != j)
					{
						tempi = i;
						tempj = j;
						clickcount = 0;
					}
					if(clickcount > 0)
					     emit sigSelectKey(QString(QChar(0x08))); 

					 m_numSelectedKey = m_numKey[i][j];
					 m_nSelectedKey = m_SmallstrKey[i][(j*3)+(clickcount++)];
				     if(clickcount == 3) clickcount = 0;

				}
				else if(m_ChangeCount == 2) // 숫자 입력
				{
					if(tempi != i || tempj != j)
					{
					   tempi = i;
					   tempj = j;
					   clickcount = 0;
				    }

					if(clickcount > 0)
						emit sigSelectKey(QString(QChar(0x08)));
					 m_numSelectedKey = m_numKey[i][j];
					 m_nSelectedKey = m_nKey[i][j];
					 if(clickcount == 3) clickcount = 0;

				}
			}
    	}

	}	
	if(!m_numSelectedKey.isNull())
    {
		p.fillRect(m_numSelectedKey,Qt::white);
		p.drawText(m_numSelectedKey,Qt::AlignCenter,m_nSelectedKey);	
    }
	if(IsSetForwardKey == false)  
	{
		 qDebug("main emit before");
		 emit sigSelectKey(m_nSelectedKey);
	}	
}
void NumPad::mouseReleaseEvent(QMouseEvent*)
{
    QPainter p(this);
    
    if(!m_numSelectedKey.isNull())
    {
		p.fillRect(m_numSelectedKey,Qt::white);
		p.drawText(m_numSelectedKey,Qt::AlignCenter,m_nSelectedKey);
    }
}
#endif
    
    
