/**
 * @file	MainWidget.cpp
 * @data	2009/09/14
 * @author	하지연(bssm16_hazi@naver.com)
 * @brief	Main Widget
*/

#include <QApplication>
#include <QtGui>
#include "trackdelegate.h"
#include "MainWidget.h"

using namespace std;

Widget::Widget()
{
		setWindowFlags(Qt::FramelessWindowHint); // 윈도우의 최소화버튼을 없앤다.	
		resize(320,480);
		
		CopyThread = new Thread();
	    CopyThread->stopped = true;
		
		connect(CopyThread,SIGNAL(SendPercent(int,int)),this,SLOT(SendPercent(int,int)));
		connect(CopyThread,SIGNAL(GetFinished(QString)),this,SLOT(GetFinished(QString)));
		connect(CopyThread,SIGNAL(GetWaited(QString)),this,SLOT(GetWaited(QString)));
		CopyThread->CurrentCount = 0;
		listpos = 0;
		IsFinished = false;
		delflag = false;
	    clickflag = false;
	    delcnt = 0;
		ReturnValue = 5;
		ButtonReturnValue =1;
		CopyThread->SendNow = false;
		countTest = 0;
		itemListCount = 0;
		VBoxLayout = new QVBoxLayout;
		VBoxLayout->setSpacing(0);
		VBoxLayout->setMargin(0);
		strcpy(DeviceType,"Wireless Lan Equiment");
		// 통신 상태 Layout 설정
		StateHBoxLayout = new QStackedLayout;
		StateHBoxLayout->setMargin(0);  //레이아웃의 외곽 간의 간격을 설정
		StateHBoxLayout->setSpacing(0); // 위젯간의 간격 설정
		VBoxLayout->addLayout(StateHBoxLayout);
		// Main Display Layout 설정
		StackedLayout = new QStackedLayout;	// Main Display Layout 생성
		VBoxLayout->addLayout(StackedLayout);
		// Main Button Layout 설정
		ButtonStiacked = new QStackedLayout; 	//Main Button Layout 생성
		VBoxLayout->addLayout(ButtonStiacked);

 		//--메인 디스플레이
		firstWidget();	// 메인페이지 생성
		StackedLayout->addWidget(FirstWidget);	// 0
		secondWidget(); // Setting페이지 생성
		StackedLayout->addWidget(SecondWidget); // 1
		thirdWidget();  // FTP페이지 생성
		StackedLayout->addWidget(ThirdWidget);  // 2
		fourthWidget(); // 데이터 전송페이지 생성
		StackedLayout->addWidget(FourthWidget); // 3
		fifthWidget();  // 데이터 전송상태 페이지 생성
		StackedLayout->addWidget(FifthWidget);    // 4

		//-- 버튼
		ButtonWidget();	// 메인 버튼 
		ButtonStiacked->addWidget(buttonWidget); //0
		UnderButtonWidget();
		ButtonStiacked->addWidget(button1Widget);//1
		
		//		Under2ButtonWidget();*/
		//-- 하위 디스플레이 설정
		USBSettingWidget();
		StackedLayout->addWidget(USBCreateWidget); // 5
		
		ButtonStiacked->setCurrentIndex(MainFirstWidget);	//초기 Display Setting
		StackedLayout->setCurrentIndex(SetMainButton);	//초기 Button Setting
		setLayout(VBoxLayout);

		if(!(loadPlugins() )){
		   	QMessageBox::information(this,"Error","Coult not load the plugin");
		}
		else{
			qDebug("StackedLayout : %d, ButtonStiacked : %d", ReturnValue+1, ButtonReturnValue+1);
			// Part of Main Widget
			wftpInterface->WSettingWidget(StackedLayout); //6
			ButtonReturnValue = wftpInterface->SetChangeButton(ButtonStiacked, ButtonReturnValue+1); // Button플러그인 등록 2
		 
		    ReturnValue = wftpInterface->WFTPmakeButton(SetVBoxLayout, ReturnValue+1);
		}
		if(!(FTPloadPlugins() )){
		   	QMessageBox::information(this,"Error","Coult not load the plugin");
			SetVBoxLayout->addStretch();
		}
		else{
			qDebug("StackedLayout : %d, ButtonStiacked : %d", ReturnValue+1, ButtonReturnValue+1);
			// Part of Main Widget
			FTPInterface->SelectFTPClientOrServer(StackedLayout);   //7
			FTPInterface->FTPClientConnect(StackedLayout);	//
			FTPInterface->FTPConnectPage(StackedLayout);	//
			// Part of Button Widget
			ButtonReturnValue = FTPInterface->WClientOrServerButton(ButtonStiacked, ButtonReturnValue+1);	//3
			FTPInterface->WClientButton(ButtonStiacked);	//4
			FTPInterface->FTPSettingButton(ButtonStiacked);	//5

			ReturnValue = FTPInterface->FTPSetButton(FTPVBoxLayout, ReturnValue+1);
		}
		if(!(FTPSettingPlugins())){
			QMessageBox::information(this,"Error","Coult not load the plugin");
		}
		else{
			qDebug("StackedLayout : %d, ButtonStiacked : %d", ReturnValue+1, ButtonReturnValue+1);
			FtpsettingInterface->FTPServerConnect(StackedLayout);    //10
            ButtonReturnValue = FtpsettingInterface->WServerButton(ButtonStiacked, ButtonReturnValue+1);	//6
			ReturnValue = FtpsettingInterface->FTPSettingButton(FTPVBoxLayout, ReturnValue+1 );
        }
		if(!(SetbluePlugins() )){
		   	QMessageBox::information(this,"Error","Coult not load the plugin");
			FTPVBoxLayout->addStretch();
		}
		else{
			qDebug("StackedLayout : %d, ButtonStiacked : %d", ReturnValue+1, ButtonReturnValue+1);
			// Part of Main Widget
			SetBInterface->SetBlueWidget(StackedLayout); //11
			SetBInterface->SetNewBlueWidget(StackedLayout);
			SetBInterface->RegisterBlueWidget(StackedLayout);
			SetBInterface->PinCodeWidget(StackedLayout);

			//Part of Button Widget
			ButtonReturnValue = SetBInterface->SetBluetoothButton(ButtonStiacked, ButtonReturnValue+1);//7
			SetBInterface->SetBlueNewButton(ButtonStiacked);
			SetBInterface->SetBlueRegisterButton(ButtonStiacked);
			SetBInterface->SetBluePinButton(ButtonStiacked);

			ReturnValue = SetBInterface->BlueSetButton(SetVBoxLayout, ReturnValue+1);
		}
}

//Main Widget 1
void Widget::firstWidget()
{
	FirstWidget = new QWidget();
	QLabel *PixmapLabel = new QLabel(FirstWidget);
	PixmapLabel->setPixmap(QPixmap("./image/in_this_wolrd.png"));
}
//-- Setting Page (USB Setting을 확인할 수 있다.) 
//--  + WLAN, Bluetooth가 Plugin으로 확장
void Widget::secondWidget()
{
	SecondWidget = new QWidget;
	QFont font("unifont");
	SecondWidget->setFont(font);
	
	SetVBoxLayout = new QVBoxLayout(SecondWidget);

	MainSetLabel = new QLabel(kor("장치 Setting"));
	SetVBoxLayout->addWidget(MainSetLabel);
	MainSetLabel->setFrameStyle(QFrame::Box | QFrame::Sunken);
	MainSetLabel->setLineWidth(1);
	MainSetLabel->setAlignment(Qt::AlignHCenter);

	// sizeHint 조절을 통해 레이아웃 상에서 기본 버튼 크기 조정한 버튼 클래스로 객체 선언.
    USetButton = new NewPushButton("USB Setting");
	SetVBoxLayout->addWidget(USetButton);
	connect(USetButton, SIGNAL(clicked()), this, SLOT(USBSettingRecevie()));
}
// Main Widget 3
void Widget::thirdWidget()
{
	ThirdWidget = new QWidget;
	QFont font("unifont");
	ThirdWidget->setFont(font);

	FTPVBoxLayout = new QVBoxLayout(ThirdWidget);

	MainFTPLabel = new QLabel(kor("Network Connect Setting"));
	FTPVBoxLayout->addWidget(MainFTPLabel);
	MainFTPLabel->setFrameStyle(QFrame::Box | QFrame::Sunken);
	MainFTPLabel->setLineWidth(1);
    MainFTPLabel->setAlignment(Qt::AlignHCenter);
}
// Main Widget 4
void Widget::fourthWidget()
{
	FourthWidget = new QWidget;

	QFont font("unifont");
	FourthWidget->setFont(font);

	TransVBoxLayout = new QVBoxLayout(FourthWidget);
	TransVBoxLayout->setSpacing(0);
	TransVBoxLayout->setMargin(0);

	QStringList messageLabels;
	messageLabels << tr("Equiement");
	UpTreeWidget = new QTreeWidget;
	UpTreeWidget->setHeaderLabels(messageLabels);
	UpTreeWidget->setColumnCount(1);
	TransVBoxLayout->addWidget(UpTreeWidget);
	
	// --- Up QTree에 리스트 추가
	Item1 = new QTreeWidgetItem(UpTreeWidget);
	Item1->setIcon(0,QIcon("./usb1.PNG"));
	Item1->setText(0,"USB_Hazi");
	Item1->setText(1,"Dir");

	BtHBoxLayout = new QHBoxLayout;
	BtHBoxLayout->setMargin(0);
	BtHBoxLayout->setSpacing(20);
	TransVBoxLayout->addLayout(BtHBoxLayout);
	
	// --- 업/다운 Button 추가
	BtHBoxLayout->addStretch();
	UpLoadButton = new QPushButton(kor("다운로드"));
	UpLoadButton->setIcon(QIcon("./image/up.png"));
	UpLoadButton->setFlat(true);  //버튼 평면화
	BtHBoxLayout->addWidget(UpLoadButton);
	connect(UpLoadButton, SIGNAL(clicked()), this, SLOT(UpLoadFunction()));
	BtHBoxLayout->addStretch();

	// --- Down QTree에 리스트 추가
	DownTreeWidget = new QTreeWidget;
	DownTreeWidget->setHeaderLabels(messageLabels);
	TransVBoxLayout->addWidget(DownTreeWidget);
	Item2 = new QTreeWidgetItem(DownTreeWidget);
	Item2->setIcon(0,QIcon("./usb2.PNG"));
	Item2->setText(0,"USB_Hong");
	Item2->setText(1,"Dir");
}
void Widget::DownLoadFunction()
{
  qDebug("file download");
	QDir *TransDir;
	QString tmp;
	if(SelectedForDownload != NULL)
	{
	    TransDir = new QDir(SelectedForDownload);
		QFileInfo info(TransDir->absoluteFilePath(SelectedForDownload));
			if(info.isFile() == true)
			qDebug("file");
		else
			qDebug("folder");

		qDebug(SelectedForDownload.toAscii());
	}
	else
		qDebug("plz ... select a down item");
	
	if(SelectedForUpload != NULL)
	{
		TransDir = new QDir(SelectedForUpload);
		QFileInfo info1(TransDir->absoluteFilePath(SelectedForUpload));
		if(info1.isFile() == true)
		{
		    qDebug("<------ file");
			tmp = SelectedForUpload; 
			int last = SelectedForUpload.lastIndexOf(QRegExp("/"));
		    int strlen = SelectedForUpload.length();
		    copytarget =  SelectedForUpload.remove(last,strlen - last);
		    qDebug("<------ target");
		    qDebug(copytarget.toAscii());
			SelectedForUpload = tmp;  
		}
	    else
		{
			qDebug("folder");
		}

		qDebug(SelectedForUpload.toAscii());
	}
	else
		qDebug("plz .. select a upload item");
		
}
Thread::Thread()
{
}
void Thread::stop()
{
     stopped = true;
}
void Widget::SendPercent(int NowPos,int itemorder)
{
	PresentItem = LoadView->topLevelItem(itemorder);	//리스트 상태가 1인값만 들고 오면됨
	if(itemTest1)
	{
		PresentItem->setText(4,QString::number(80));
		getTestResult = NowPos;
		PresentItem->setText(4,"Finished");
		PresentItem->setText(3,"Sending");	
		itemListCount = itemorder;
		sumFunction();
		getProgressInfo();

	}
	else	PresentItem->setText(3,"Finished");
}
// 파일 교환 루틴 수행을 위한 스레드
void Thread::run()
{
	
	while(1)
	{
		    usleep(5000);
			mutex.lock();
			source =  FileWaitList.first();
			FileWaitList.removeFirst();
			dest =  FileWaitList.first();
			FileWaitList.removeFirst();
			mutex.unlock();

			copyfile(source.toAscii().data(),dest.toAscii().data());
			qDebug(source.toAscii());
			if(FileWaitList.isEmpty() == true) 
			{
					break;
			}
	}

}

// Main Widget 5
void Widget::fifthWidget()
{
	TempotaryStopFlag = 0;
	FifthWidget = new QWidget;
	QFont font("unifont");
	FifthWidget->setFont(font);
	FHBoxLayout = new QHBoxLayout(FifthWidget);
	FHBoxLayout->setMargin(0);
	FHBoxLayout->setSpacing(0);

	QStringList headers;
	headers << kor("보내는 장치") << kor("받는 장치") << kor("전송파일") << kor("상태") << kor("프로그래스");

	LoadView = new QTreeWidget();
	//델레게이트 넣기
	LoadView->setHeaderLabels(headers);	//Header 부분
	LoadView->setItemDelegate(new TorrentViewDelegate(this));
	LoadView->setSelectionBehavior(QAbstractItemView::SelectRows);
	LoadView->setAlternatingRowColors(true);
	LoadView->setRootIsDecorated(false);
	//LoadView->setColumnCount(5);
	LoadView->header()->setResizeMode(QHeaderView::Fixed);
	FHBoxLayout->addWidget(LoadView);

	QFileInfo fi("/usr/local/qt4/Coding/DenProject3/DenProject3_6/MainWidget.cpp");
	
	int a = fi.size();
	QString Atype = fi.fileName();
	QString Btype = fi.fileName();
	QString SendFile = fi.fileName();
	int StateOfFile = 0;
	
	connect(LoadView, SIGNAL(itemClicked(QTreeWidgetItem *,int)), this, SLOT(itemDelete(QTreeWidgetItem *)));


	FVBoxLayout = new QVBoxLayout;
    FVBoxLayout->setSpacing(0);
	FVBoxLayout->setMargin(0);	
	FHBoxLayout->addLayout(FVBoxLayout);
	FPushButton = new QPushButton;
	FPushButton->setIcon(QIcon("./image/126.png"));
	FVBoxLayout->addWidget(FPushButton);
	FPushButton->setFlat(true);
	FPushButton->setFocusPolicy(Qt::NoFocus);
	
	FPushButton1 = new QPushButton;
	FPushButton1->setIcon(QIcon("./image/128.png"));
	FPushButton1->setFlat(true);
	FPushButton1->setFocusPolicy(Qt::NoFocus);
	FVBoxLayout->addWidget(FPushButton1);
	connect(FPushButton1, SIGNAL(clicked()), this, SLOT(ListDelete()));

	FPushButton2 = new QPushButton;
	FPushButton2->setIcon(QIcon("./image/98.png"));
	FPushButton2->setFlat(true);
	FPushButton2->setFocusPolicy(Qt::NoFocus);
	FVBoxLayout->addWidget(FPushButton2);

	FPushButton3 = new QPushButton;
	FPushButton3->setIcon(QIcon("./image/91.png"));
	FPushButton3->setFlat(true);
	FPushButton3->setFocusPolicy(Qt::NoFocus);
	FVBoxLayout->addWidget(FPushButton3);

	connect(FPushButton2, SIGNAL(clicked()), this, SLOT(TempotaryStop()));
}
void Widget::itemDelete(QTreeWidgetItem *)
{
	QModelIndex TreeWidgetIndex = LoadView->currentIndex();
	TreeIndexforDelete = TreeWidgetIndex.row();
	qDebug("%d",TreeIndexforDelete);
}
void Widget::ListDelete()
{
	if(TreeIndexforDelete != -1)
	{
		LoadView->takeTopLevelItem(TreeIndexforDelete);
	}

}

void Widget::TempotaryStop()
{
	if(TempotaryStopFlag == 0)
	{
		FPushButton2->setIcon(QIcon("./image/93.png"));
		TempotaryStopFlag = 1;
	}
	else{
		FPushButton2->setIcon(QIcon("./image/98.png"));
	}

}
void Widget::GetProgressFileInfo(QString a, QString b, QString file, int state)
{
		itemTest1 = new QTreeWidgetItem(LoadView);
	 	itemTest1->setText(0,a);

	 	itemTest1->setText(1,b);
	 	itemTest1->setText(2,file);
		
		if(state == 0){
			qDebug("waiting");
			QString WaitState = "Waiting";
	 		itemTest1->setText(3, WaitState);
			getTestResult = 0;
			countTest = countTest+1;;
		}
		else if(state == 1){
			 qDebug("sending");
			QString SendState = "Sending";
			itemTest1->setText(3, SendState);
			itemTest1->setText(4,"0");
			IndexRowWidget = sending;	//전송중인 상태 체크	
			RowIndex();
			sumFunction();
		}
}
/*
  @brief 파일 전송 상태 갱신. 전송이 완료 되었다면,전송완료로 트리위젯을 갱신하여 준다.
  @param 파일 전송 상태
*/
void Widget::GetFinished(QString checkstate)
{
	QList<QTreeWidgetItem*> ch;
	qDebug(checkstate.toAscii());
	 ch = LoadView->findItems(checkstate,Qt::MatchExactly | Qt::MatchRecursive,2);
	int num = ch.count();
	 qDebug("num~ : %d\n",num);
	
	 cout << ch.first();
	 QTreeWidgetItem *chitem = new QTreeWidgetItem();
	 chitem =  ch.first();
	 ch.takeFirst();

	 chitem->setText(4,QString::number(80));
	 chitem->setText(4,"Finished");
	 chitem->setText(3,"Finished");
	 qDebug(chitem->text(0).toAscii());
	 qDebug(chitem->text(1).toAscii());
	 qDebug(chitem->text(2).toAscii());
	 qDebug(chitem->text(3).toAscii());
		 
	 qDebug("Finished");
}
void Widget::GetWaited(QString checkstate)
{
	//itemTest1 = LoadView->topLevelItem(itemorder);
	//itemTest1->setText(3,"Sending");	
	qDebug("********************************************"); 
	 QList<QTreeWidgetItem*> ch;

   	 ch = LoadView->findItems(checkstate,Qt::MatchStartsWith,0);


	 QTreeWidgetItem *chitem = new QTreeWidgetItem();
	 chitem =  ch.first();
	 ch.takeFirst();
	 chitem->setText(3,"Sending");
	 qDebug(chitem->text(0).toAscii());

}
void Widget::update()
{
	itemTest1->setText(3, "Sending");
}
int Widget::getProgressInfo()
{
//	 qApp->processEvents();
	return getTestResult;
}
int Widget::RowIndex()
{
	return IndexRowWidget; 
}
int Widget::sumFunction()
{
	return itemListCount; 
}
// @brief 선택된 파일 목록을 파일 전송 대기 리스트에 쌓고, copyfile 함수를 호출.
void Widget::UpLoadFunction()
{
	qDebug("file upload");
	QDir *TransDir;
	QString tmp;
	QString SendFileName;
	if(SelectedForDownload != NULL)
	{
		 TransDir = new QDir(SelectedForDownload);
		 QFileInfo info(TransDir->absoluteFilePath(SelectedForDownload));
		 if(info.isFile() == true)
		 {
		         qDebug("---- >file");
   			 tmp = SelectedForDownload;
			 int last = SelectedForDownload.lastIndexOf(QRegExp("/"));
             int strlen = SelectedForDownload.length();
             copytarget =  SelectedForDownload.remove(last,strlen - last);
             qDebug("---->target");
             qDebug(copytarget.toAscii());
			 SelectedForDownload = tmp;
		 }
		 else
		         qDebug("folder");
    	 qDebug(SelectedForDownload.toAscii());	
	}
	else
	     qDebug("plz ... select a down item");
    if(SelectedForUpload != NULL )
	{
		   TransDir = new QDir(SelectedForUpload);
		   QFileInfo info1(TransDir->absoluteFilePath(SelectedForUpload));
		   if(info1.isFile() == true)
		        qDebug("file");
		   else
		        qDebug("folder");
		   int wordstart = SelectedForUpload.lastIndexOf(QRegExp("/"));
		   int wordlen = SelectedForUpload.length();
		   SendFileName = SelectedForUpload.right(wordlen - wordstart);
		   qDebug(SendFileName.toAscii());

	}	
	else
        qDebug("plz .. select a upload item");
	
	 qDebug("file Trans");
     copytarget = copytarget + SendFileName;

     sending = 0;

	 if(CopyThread->SendNow == false){
	  	 sending = 1;	//1일때 전송중
	 }
	 else	  
		 sending = 0;
		
	CopyThread->mutex.lock();
	GetProgressFileInfo("usb","usb",SendFileName,sending);
	CopyThread->FileWaitList << SelectedForUpload << copytarget ;
	CopyThread->mutex.unlock();

	if(CopyThread->isRunning() == false)
	 {
		 CopyThread->start();
	 }
}

//Main Button 생성
void Widget::ButtonWidget()
{
	buttonWidget = new QWidget;
	ButtonHBoxLayout = new QHBoxLayout(buttonWidget);
	ButtonHBoxLayout->setMargin(0);
	ButtonHBoxLayout->setSpacing(0); 

	//--------- Main Button Create 1 ------------
	PushButton = new QPushButton(this);
	PushButton->setIcon(QIcon("./image/Home.png"));
	PushButton->setFlat(true);	//버튼 평면화
	PushButton->setFocusPolicy(Qt::NoFocus);	//버튼 포커스 설정
    ButtonHBoxLayout->addWidget(PushButton);
    connect(PushButton, SIGNAL(clicked()), this, SLOT(ChangeMain1Widget()));
    //--------- Setting Button Create 2 -----------
	PushButton2 = new QPushButton(this);
    PushButton2->setIcon(QIcon("./image/custo.png"));
	PushButton2->setFlat(true);
	PushButton2->setFocusPolicy(Qt::NoFocus);
	ButtonHBoxLayout->addWidget(PushButton2);
    connect(PushButton2, SIGNAL(clicked()), this, SLOT(ChangeMain2Widget()));
	//--------- FTP Button Create 3 --------------
	PushButton3 = new QPushButton(this);
    PushButton3->setIcon(QIcon("./image/Connect_To.png"));
    PushButton3->setFlat(true);
	PushButton3->setFocusPolicy(Qt::NoFocus);
	ButtonHBoxLayout->addWidget(PushButton3);
    connect(PushButton3, SIGNAL(clicked()), this, SLOT(ChangeMain3Widget()));
	//--------- File 교환 방 4 ----------------
	PushButton4 = new QPushButton(this);
    PushButton4->setIcon(QIcon("./image/Downloads.png"));
	PushButton4->setFlat(true);
    PushButton4->setFocusPolicy(Qt::NoFocus);
   	ButtonHBoxLayout->addWidget(PushButton4);
    connect(PushButton4, SIGNAL(clicked()), this, SLOT(ChangeMain4Widget()));
    //--------- 전송 상태 방 5 ----------------
   	PushButton5 = new QPushButton(this);
    PushButton5->setIcon(QIcon("./image/Desk.png"));
	PushButton5->setFlat(true);
	PushButton5->setFocusPolicy(Qt::NoFocus);
    ButtonHBoxLayout->addWidget(PushButton5);
    connect(PushButton5, SIGNAL(clicked()), this, SLOT(ChangeMain5Widget()));
	//--------- 종료 버튼 6 ---------------- 
	CancelButton = new QPushButton(this);
	CancelButton->setIcon(QIcon("./image/Shutdown.png"));
	CancelButton->setFlat(true);
	CancelButton->setFocusPolicy(Qt::NoFocus);
	ButtonHBoxLayout->addWidget(CancelButton);
	connect(CancelButton, SIGNAL(clicked()), qApp, SLOT(quit()));
}
 //Setting USB Button Clicked SLOT Function
 void Widget::USBSettingWidget()
 {
      USBCreateWidget = new QWidget;
  
      QFont font("unifont");
      USBCreateWidget->setFont(font);
      UCreateVBoxLayout = new QVBoxLayout(USBCreateWidget);
  
      UCreateLabel = new QLabel(kor("연결되어 있는 USB"));
      UCreateVBoxLayout->addWidget(UCreateLabel);
      UCreateLabel->setFrameStyle(QFrame::Box | QFrame::Sunken);
      UCreateLabel->setLineWidth(1);
      UCreateLabel->setAlignment(Qt::AlignHCenter);
      listwidget = new QListWidget;
      UCreateVBoxLayout->addWidget(listwidget);
      //listwidget 에 추가 
      
      USetInfo = new QLabel("");
      UCreateVBoxLayout->addWidget(USetInfo);
      //USetInfo->setFrameStyle(QFrame::Box | QFrame::Sunken);
      //USetInfo->setLineWidth(1);
 }
 /*
      @brief USB 메모리 스틱의 장치 명 출력.
	  @date 2009/10/07
	  @author 안병기(sixthman23@naver.com) 
*/

char* Widget::GetUSBModelName(char* target ,char *message)
{
	     char* temp = NULL;
	     char* model = NULL;
	     char* tempval = NULL;
	     char* modelname = NULL;
	     int wordcount = 0;
	     char trim[256];
	     char *end;
	     temp = strstr(target,message);
	     if(temp != NULL)
	     {
	        model = temp +( strlen(message) + 1);
	        tempval = model;
	        while(*tempval != '\"')
	        {
	            tempval++;
	            wordcount++;
		    }
		    modelname = (char*) malloc (wordcount);
		    memset(modelname,0,wordcount);
		    strncpy(modelname,model,wordcount);
		    modelname[wordcount] = '\0';
		    strcpy(trim,modelname);
		    //문자열 뒤쪽 공백 제거
		   	end = trim + strlen(trim) -1;
		    while(end != trim && *end == ' ')
		    end--;
		    *(end+1) = '\0';
		    modelname = trim;
		    return modelname;
		 }
		   if(temp == NULL)
		   {	
			   modelname = NULL;
			   return modelname;
		   }
}	
 
//하위 디스플레이 버튼 설정
void Widget::UnderButtonWidget()
{
		button1Widget = new QWidget;

		Button1HBoxLayout = new QHBoxLayout(button1Widget);	
   		Button1HBoxLayout->setMargin(0);
	    Button1HBoxLayout->setSpacing(0);

	    Push1Button = new QPushButton(QIcon("./image/Home.png"),"Main");
		Push1Button->setFocusPolicy(Qt::NoFocus);    //버튼 포커스 설정
		Push1Button->setFlat(true);  //버튼 평면화
  		Button1HBoxLayout->addWidget(Push1Button);
		connect(Push1Button, SIGNAL(clicked()), this, SLOT(ChangeMain1Widget()));

		Push2Button = new QPushButton(QIcon("./image/Drive.png"),kor("장치제거"));
		Push2Button->setFocusPolicy(Qt::NoFocus);    //버튼 포커스 설정
		Push2Button->setFlat(true);  //버튼 평면화
		connect(Push2Button, SIGNAL(clicked()), this, SLOT(RemoveUSBDevice()));
		Button1HBoxLayout->addWidget(Push2Button);

		QPushButton *Push3Button = new QPushButton(QIcon("./image/Delete2.png"),kor("취소"));
		Push3Button->setFocusPolicy(Qt::NoFocus);    //버튼 포커스 설정
		Push3Button->setFlat(true);  //버튼 평면화
		connect(Push3Button, SIGNAL(clicked()), this, SLOT(ChangeMain2Widget()));
		Button1HBoxLayout->addWidget(Push3Button);
}
/*
     @brief 선택된 USB 장치 제거
     @date 2009/10/08
     @athor 안병기 (sixthman23@naver.com)    
*/

void Widget::RemoveUSBDevice()
{
	if(listwidget->count() != 0 && MntInfo != NULL)
	{
	    QString strProgram = "umount " + MntInfo;
	    QProcess::execute(strProgram);
	    qDebug(listwidget->item(listwidget->currentRow())->text().toAscii());
		QString num;
		num.setNum(cur);

	    listwidget->takeItem(listwidget->currentRow());
		USetInfo->clear();
		qDebug(strProgram.toAscii());
	}
}

// Plugin ------------------------------------------------------------------
bool Widget::loadPlugins()
{
     QDir pluginDir = directoryOf("./Plugins");
   	 
	 foreach (QString fileName, pluginDir.entryList(QDir::Files)){
		 QPluginLoader loader(pluginDir.absoluteFilePath("libConnectPlugin.so"));
	 	 QObject *plugin = loader.instance();
		 if(plugin){
             wftpInterface = qobject_cast<WFTPInterface *>(plugin);
		   	 if(wftpInterface)  
				 return true;			 
	   	 }
	 }return false;
}
bool Widget::FTPloadPlugins()
{
	QDir pluginDir = directoryOf("./Plugins");

	foreach (QString fileName, pluginDir.entryList(QDir::Files)){
		QPluginLoader loader(pluginDir.absoluteFilePath("libFTPSetPlugin.so"));
		QObject *plugin = loader.instance();
        if(plugin){
			FTPInterface = qobject_cast<FTPSetInterface *>(plugin);
             if(FTPInterface)
			     return true;
			}
	   } return false;
}

bool Widget::SetbluePlugins()
{
	QDir pluginDir = directoryOf("./Plugins");

	foreach (QString fileName, pluginDir.entryList(QDir::Files)){
    QPluginLoader loader(pluginDir.absoluteFilePath("libSetBluePlugin.so"));
                  QObject *plugin = loader.instance();
        if(plugin){
			SetBInterface = qobject_cast<SetBlueInterface *>(plugin);
			if(SetBInterface)
				return true;
		}
	}return false;
}

bool Widget::FTPSettingPlugins()
{
	QDir pluginDir = directoryOf("./Plugins");

	foreach (QString fileName, pluginDir.entryList(QDir::Files)){
		QPluginLoader loader(pluginDir.absoluteFilePath("libFTPSettingPlugin.so"));
		QObject *plugin = loader.instance();
		if(plugin){
			FtpsettingInterface = qobject_cast<FTPSettingInterface *>(plugin);
			if(FtpsettingInterface)
				return true;
			}
	}return false;
}

QDir Widget::directoryOf(const QString &subdir)
{
         QDir dir(QApplication::applicationDirPath());
             dir.cd(subdir);
                 return dir;
}
//End of Plugin Function ---------------------------------------------------
//Main Button SLOT 
void Widget::ChangeMain1Widget()
{
	StackedLayout->setCurrentIndex(MainFirstWidget);	
	ButtonStiacked->setCurrentIndex(SetMainButton);
}
void Widget::ChangeMain2Widget()
{   
   	StackedLayout->setCurrentIndex(MainSecondWidget); // Setting Page
	ButtonStiacked->setCurrentIndex(SetMainButton);
	SetVBoxLayout->addStretch();
}
void Widget::ChangeMain3Widget()
{   
   	StackedLayout->setCurrentIndex(MainThridWidget);
	ButtonStiacked->setCurrentIndex(SetMainButton);
	FTPVBoxLayout->addStretch();
}
void Widget::ChangeMain4Widget()
{
	
	FolderInfo.clear();
	UpFolderInfo.clear();
	GetUSBInfo();
	qDebug("usb set");
	StackedLayout->setCurrentIndex(MainFourthWidget); 
	ButtonStiacked->setCurrentIndex(SetMainButton);
} 
void Widget::ChangeMain5Widget()
{
	StackedLayout->setCurrentIndex(MainFifthWidget);
	ButtonStiacked->setCurrentIndex(SetMainButton);
}
/*
 	@breif 디바이스 노드에 물려있는 장치 노드 검색. 현재 사용 가능한  USB 장치 목록 검색
  	@atuthor 안병기 (sixthman23@naver.com)
 */
void Widget::GetUSBInfo()
{	
		
	  FILE *read_fp = NULL; // 노드 여부 검사위한 파이프
	  FILE *find_fp = NULL; // 장치명 검사를 위한 파이프

      listwidget->clear();
	  FindUSBDevInfo.clear();
	  disconnect(listwidget,SIGNAL(itemClicked(QListWidgetItem *)),this,SLOT(GetUSBInformation(QListWidgetItem*)));
	  disconnect(UpTreeWidget,SIGNAL(itemClicked(QTreeWidgetItem *,int)),this,SLOT(GetUsbInFileInfo(QTreeWidgetItem*)));
 	  //disconnect(DownTreeWidget,SIGNAL(itemClicked(QTreeWidgetItem *,int)),this,SLOT(DownloadItem(QTreeWidgetItem*)));

      int cnt = 96;
      int i = 0;
	  int j = 0;
      int checknum = 0;
	  Modelresult = NULL;
	  Vendorresult = NULL;
	  memset(temp1,0,sizeof(temp1));
	  memset(temp2,0,sizeof(temp2));
	  QList<QListWidgetItem *> items;

	  sprintf(udevopen,"udevinfo -q path -n /dev/sd%c1",++cnt);
	  // USB 장치 검색, sda1~sde1 사이에 할당되는 장치 유무를 확인. 
	  for(i = 0 ; i < 4; i++)
	   {
		    //qApp->processEvents();
	      if((read_fp = popen(udevopen,"r")) == NULL)
	      {
	         perror("popen failed");
	         exit(1);
	      }
		  sleep(1);
	      memset(buffer,0,sizeof(buffer));
	      fgets(buffer,sizeof(buffer),read_fp);
	      // USB가 /dev 밑에 할당되어 노드를 가지고 있는지의 여부를 체크.  
	
		  if(strlen(buffer) == 0)
		  {
	        printf("Not Found\n");
			checknum++;
			if(checknum == 4)
			{
				checknum = 0;
		  		goto exit;
			}
		  }
	      else
	      {
	         memset(temp1,0,sizeof(temp1));
	         memset(temp2,0,sizeof(temp2));
	         memset(FindForDeviceName,0,sizeof(FindForDeviceName));
	         sprintf(FindForDeviceName,"udevinfo -a -p /sys%s",buffer);
			 //printf("%s\n",FindForDeviceName);	
			 //printf("Name len:%d\n",strlen(FindForDeviceName));
			 if((find_fp = popen(FindForDeviceName,"r")) == NULL)
	         {
	             perror("popen failed");
	             exit(1);
	         }
			 sleep(1);
	         memset(buffer,0,sizeof(buffer));
	    
			 // USB가 노드를 가지고 있다면 USB 장치명 검색.
	         while(fgets(buffer,sizeof(buffer),find_fp))
	         {
				 //fputs(buffer,stdout);
		           Vendorresult = GetUSBModelName(buffer,"ATTRS{vendor}==");
		          
				   if(Vendorresult != NULL)
					   strcpy(temp1,Vendorresult);
				  
				   Modelresult = GetUSBModelName(buffer,"ATTRS{model}==");
				  
				   if(Modelresult != NULL)
				      strcpy(temp2,Modelresult);
		      }
		         if(strlen(temp1) != 0 && strlen(temp2) != 0)  
				 {
		              memset(DeviceName,0,sizeof(DeviceName));
		              strcat(DeviceName,temp1);
		              strcat(DeviceName," ");
		              strcat(DeviceName,temp2);
		              strcat(DeviceName," USB Device");
					  
					  QString temp = QString(DeviceName);											  
					  memset(tempDev,0,sizeof(tempDev));
					  memset(devinfo,0,sizeof(devinfo));
					  sprintf(tempDev,"%s%d",DeviceName,i);
					  items.append(new QListWidgetItem(QIcon("./image/usb1.png"),QString(DeviceName),listwidget));
					  sprintf(devinfo,"/dev/sd%c1",cnt);
					  FindUSBDevInfo.insert(QString(tempDev),QString(devinfo));
		           }
				  j++;
		 	}
		    qApp->processEvents();

		  if(strlen(temp1) != 0 && strlen(temp2) != 0)
		  {
		 	sprintf(udevopen,"udevinfo -q path -n /dev/sd%c1",++cnt);
		  }
	 }
	 pclose(find_fp);
exit:
	 qApp->processEvents();

	 QList<QTreeWidgetItem *> items2;
	 QList<QTreeWidgetItem *> downit;
	 QHashIterator<QString,QString> k(FindUSBDevInfo);
     QTreeWidgetItem *itembay;
	 QTreeWidgetItem *downitem;
	 QTreeWidgetItem *SubDirItem;
	 QTreeWidgetItem *DownDirItem;
	 QList<QTreeWidgetItem *> Sub;
	 int ct = 0;	 
	 
	 UpTreeWidget->clear();
	 DownTreeWidget->clear();
	 while(k.hasNext())
	 {
	  	k.next();
		// 업로드 창에 정보 출력
		itembay = new QTreeWidgetItem(UpTreeWidget,QStringList(k.key()));
        itembay->setIcon(0,QIcon("./image/usb1.png"));
		items2.append(itembay);
	    	
		// 다운로드 창에 정보 출력
		downitem = new QTreeWidgetItem(DownTreeWidget,QStringList(k.key()));
		downitem->setIcon(0,QIcon("./image/usb2.png"));
		downit.append(downitem);
		

		char tmpfile[256];
	    memset(tmpfile,0,sizeof(tmpfile));
	    strcpy(tmpfile,FileViewInfo(k.key().toAscii().data()));
		QDir dir((QString(tmpfile).remove( (QString(tmpfile).lastIndexOf(QRegExp("\n"))),1 ) ));
		DownPathInfo.insert(k.key(),(QString(tmpfile).remove( (QString(tmpfile).lastIndexOf(QRegExp("\n"))),1 ) ));
	    dir.setCurrent(tmpfile);

	    // USB 마운트 된 폴더 하위 내용 출력 
		for(int i = 0 ; i < dir.count() ; i++)
	    {
				
		        PathInfo.insert(dir[i],(QString(tmpfile).remove( (QString(tmpfile).lastIndexOf(QRegExp("\n"))),1)));	
				SubDirItem = new QTreeWidgetItem(itembay,QStringList(kor(dir[i].toAscii())));
				QString pathval =  rootPath(SubDirItem);	
				QFileInfo DirOrFile(pathval.remove(pathval.lastIndexOf(QRegExp("/")),1));
				if(DirOrFile.isFile() == true)
					SubDirItem->setIcon(0,QIcon("./image/file.png"));	
				else	
					SubDirItem->setIcon(0,QIcon("./image/folder.png"));
				
			    itembay->addChild(SubDirItem);
				
				DownDirItem = new QTreeWidgetItem(downitem,QStringList(kor(dir[i].toAscii())));

			   if(DirOrFile.isFile() == true)	
			   {
					DownDirItem->setIcon(0,QIcon("./image/file.png"));
			   }
			   else 
				   DownDirItem->setIcon(0,QIcon("./image/folder.png"));

			   	downitem->addChild(DownDirItem);
		}
		
		if(itembay->isExpanded() == false)
		{
		   itembay->setExpanded(true );		   
     	}
		if(downitem->isExpanded() == false)
		{
			downitem->setExpanded(true);
		}
     }
	 
	   
	  UpTreeWidget->insertTopLevelItems(0,items2);
	  FTPInterface->Calldir(UpTreeWidget,DownTreeWidget);	
	  
	  pclose(read_fp);
	  connect(listwidget,SIGNAL(itemClicked(QListWidgetItem *)),this,SLOT(GetUSBInformation(QListWidgetItem*)));
 	  connect(UpTreeWidget,SIGNAL(itemClicked(QTreeWidgetItem *,int)),this,SLOT(GetUsbInFileInfo(QTreeWidgetItem*)));	 
	  connect(DownTreeWidget,SIGNAL(itemClicked(QTreeWidgetItem *,int)),this,SLOT(DownloadItem(QTreeWidgetItem*)));

}
//USB SetButton Clicked
void Widget::USBSettingRecevie()
{	
	GetUSBInfo();
	StackedLayout->setCurrentIndex(SetUSBButtonWidget);
	ButtonStiacked->setCurrentIndex(SettingButton);
}
QString Widget::GetMountInfo(char* mntinfo)
{
	return QString(mntinfo);
}
char* Widget::FileViewInfo(char *devname)
{ 
  FILE *Info_fp = NULL;
  struct UsbInfo info;
  char InfoBuffer[256];
  char *ptr;
  char tempch[256];
  int i = 0;
  char DevInfo1[256];
  char returnval[256];
  memset(DevInfo1,0,sizeof(DevInfo1));
  memset(InfoBuffer,0,sizeof(InfoBuffer));
  memset(returnval,0,sizeof(returnval));
	 
	QString Find1;
	QString devfind;
	if(FindUSBDevInfo.contains(QString(devname)))
	{
	     Find1 = FindUSBDevInfo.value(QString(devname));
		   qDebug(Find1.toAscii());
		   strcpy(tempch,Find1.toAscii());
		   sprintf(DevInfo1,"df %s",tempch);
		   if((Info_fp = popen(DevInfo1,"r")) == NULL)
		   {
		      perror("popen failed");
		      exit(1);
		   } 
			  sleep(1);
		   fgets(InfoBuffer,sizeof(InfoBuffer),Info_fp); // 첫 번째 줄 Skip 하기 위함. 
		   while(fgets(InfoBuffer,sizeof(InfoBuffer),Info_fp)) // 지정된 장치만 사용 정보 출력.
		   {
		      ptr = strtok(InfoBuffer," ");
		         while(ptr != NULL)
		         {
			        ptr = strtok(NULL," ");
					     if(i == 4)
					     {
						 	strcpy(returnval,ptr);
							qDebug("**");
							qDebug(returnval);
							qDebug("**");
						 }
						   i++;
				  }
				         ptr = NULL;
				        memset(InfoBuffer,0,sizeof(InfoBuffer));
			}
	}
			  pclose(Info_fp);
			 return returnval;
}
void Widget::GetUsbInFileInfo(QTreeWidgetItem* item) // 첫 번째 트리 위젯 처리
{
	SecondDevice  = rootPathForWlan(item);
	if(SecondDevice != QString(DeviceType))
	{

		QString RootDevItem = rootPath(item);
		
		RootDevItem = RootDevItem.remove(RootDevItem.lastIndexOf(QRegExp("/")),1);
		SelectedForDownload = RootDevItem;

		qDebug(SelectedForDownload.toAscii());

		QTreeWidgetItem* childitem;
		QTreeWidgetItem* parentitem = new QTreeWidgetItem();
	   	parentitem = item->parent();
		QString SearchResult = DownPathInfo.value(RootDevItem).toAscii();
		QString par;
	
			if(parentitem != NULL)
			{
				Listdir = new QDir(RootDevItem); 

				QFileInfo info(Listdir->absoluteFilePath(RootDevItem));
    			qDebug(item->parent()->text(0).toAscii());  
		
       		 	if(info.isFile() == true)
				{
					qDebug("Is File");	
				}
        		else
				{
					qDebug(Listdir->absoluteFilePath(RootDevItem).toAscii());
			 		if(FolderInfo.value(RootDevItem) == NULL && item->text(0) != "." && item->text(0) !=  ".." )
			 		{
			 			QDir dir1(Listdir->absoluteFilePath(RootDevItem));
						for(int i = 0 ; i < dir1.count() ; i++)
						{
				
							childitem = new QTreeWidgetItem(item,QStringList(kor(dir1[i].toAscii())));
							QString pathval =  rootPath(childitem);
							QFileInfo DirOrFile(pathval.remove(pathval.lastIndexOf(QRegExp("/")),1));
					  		if(DirOrFile.isFile() == true)
					  	 		 childitem->setIcon(0,QIcon("./image/file.png"));
					  		else	  
						 		 childitem->setIcon(0,QIcon("./image/folder.png"));
							item->addChild(childitem);
						}
			 				if(item->isExpanded() == false)
					  			item->setExpanded(true);
			 	
			 				FolderInfo.insert(RootDevItem,"1");
		    		}
					else 
							qDebug("Return");

				}		
			}	
	}
	else
	{
		 QString IsFTPFolder =  FTPInterface->CheckFtpFileInfo(item->text(0));
		 qDebug(IsFTPFolder.toAscii());
		 if(IsFTPFolder == QString("folder"))
		 {
		    FTPInterface->FtpDo_Dir(item->text(0),item);
	     }
	}
	
}
void Widget::HasChildren(QString)
{

}
 /*
	@brief 선택된 트리 위젯 아이템의 부모 위젯 아이템을 찾는다.
    @date 2009/10/10
    @param 선택된 트리 위젯 아이템
    @return 선택된 트리 위젯이 차일드 아이템일 경우 자신의 바로 위 부모 아템을 찾아 반환한다.
    @athor  안병기(sixthman23@naver.com) 
*/
QString Widget::pathTo(QTreeWidgetItem *item, QTreeWidgetItem *parent)
{
	QTreeWidgetItem *p = item;
	QString path;
	while(p)
	{
		path = path.prepend(p->text(0) + "/");
		if(p == parent ) break;
		p = p->parent();
	}
	return path;
}
/*
    @brief 선택된 트리 위젯 아이템의 최상위 부모 위젯을 찾는다.
    @date 2009/10/10
    @param 선택된 트리 위젯 아이템
    @return 선택된 트리 위젯이 차일드 아이템일 경우 최상위 부모 아이템을 찾아 반환한다.
    @athor 안병기(sixthman23@naver.com)
*/ 
QString Widget::rootPath(QTreeWidgetItem *item)  // 루트 폴더를 찾는다.
{
	QTreeWidgetItem *p = item;
	QString path;

	while(p)
	{
		//path =  p->text(0);
	    if(DownPathInfo.value(p->text(0)) != NULL)
		{
		    path = path.prepend(DownPathInfo.value(p->text(0))  + "/");
		}
		else			
			path = path.prepend(p->text(0) + "/");
		p = p->parent();
	}
	return path;
}
// 최상위 부모 아이템을 검색하여 반환한다.
QString Widget::rootPathForWlan(QTreeWidgetItem *item)
{
	QTreeWidgetItem *p = item;
	QString path;
	int i = 0;
	while(p)
	{
		path = p->text(0);		
		p = p->parent();
	}
	return path;
}

/*
     @brief 트리 위젯에서 아이템 선택시 폴더,파일 여부 검사후 하위 목록 출력
     @date 2009/10/09
     @param 선택된 트리 위젯 아이템 ( 폴더 혹은 파일 이름 )
     @athor 안병기(sixthman23@naver.com)
*/
void Widget::DownloadItem(QTreeWidgetItem* item)
{
    FirstDevice = rootPathForWlan(item);	
	if(FirstDevice != QString(DeviceType))   // 최상위 부모 위젯이 USB 장치인 경우
	{
		QString RootDeviceItem = rootPath(item);	 
 
		RootDeviceItem = RootDeviceItem.remove(RootDeviceItem.lastIndexOf(QRegExp("/")),1);
		SelectedForUpload = RootDeviceItem;
	
		QTreeWidgetItem* childitem;

		QTreeWidgetItem* parentitem = new QTreeWidgetItem();
		parentitem = item->parent();


		if(parentitem != NULL)
		{
        
			Listdir = new QDir(RootDeviceItem);
	    	QFileInfo info(Listdir->absoluteFilePath(RootDeviceItem));
	    	qDebug(item->parent()->text(0).toAscii());
	
			if(info.isFile() == true) 
				qDebug("is a file");
			else
			{	
				qDebug("is a folder");
				qDebug(Listdir->absoluteFilePath(RootDeviceItem).toAscii());
		    	if(UpFolderInfo.value(RootDeviceItem) == NULL && item->text(0) != "." && item->text(0) !=  ".." )
		    	{
		        	QDir dir1(Listdir->absoluteFilePath(RootDeviceItem));
		        
					for(int i = 0 ; i < dir1.count() ; i++)
					{
						childitem = new QTreeWidgetItem(item,QStringList(kor(dir1[i].toAscii())));
			    		QString pathval =  rootPath(childitem);
						QFileInfo DirOrFile(pathval.remove(pathval.lastIndexOf(QRegExp("/")),1));
				
							if(DirOrFile.isFile() == true)
								childitem->setIcon(0,QIcon("./image/file.png"));
							else	
				   				childitem->setIcon(0,QIcon("./image/folder.png"));
				 
								item->addChild(childitem);
					}		
                			if(item->isExpanded() == false)
                    			item->setExpanded(true);
                  				UpFolderInfo.insert(RootDeviceItem,"1");
            	}
            	else
                	qDebug("Return");

		}
	}
}
else // 최상위 부모 아이템이 무선랜인 경우 ...
{	
	QString IsFTPFolder =  FTPInterface->CheckFtpFileInfo(item->text(0));
	qDebug(IsFTPFolder.toAscii());
	if(IsFTPFolder == QString("folder"))
	{
		FTPInterface->FtpDo_Dir(item->text(0),item);
	}
}
	qDebug("download them");
}
QTreeWidgetItem* Widget::createTreeWidgetItem(QTreeWidgetItem *parent, const QStringList &path)
{
	if(path.isEmpty()) return NULL;
	if(!parent) return NULL;

	QTreeWidgetItem *child, *p = parent;

	QStringList li = path;
	QString num;
	num.setNum(parent->childCount());
	for(int i = 0 ; i < parent->childCount(); ++i)
	{
		child = parent->child(i);
		if(child->text(0) != li[0]) 
		{
			continue;
		}
		li.removeFirst();
		if(li.isEmpty())
			return child;

		return createTreeWidgetItem(child,li);
	}

	child = new QTreeWidgetItem(parent,QStringList() << li[0]);
	li.removeFirst();
	if(li.isEmpty())
		return child;

	return createTreeWidgetItem(child,li);
}
/*
     @brief USB 장치 정보 출력 
     @date 2009/10/09
     @author 안병기(sixthman23@naver.com)
*/
void Widget::GetUSBInformation(QListWidgetItem* item)
{	


	//char *Findit = NULL;
	if(clickflag == true) return;
	qDebug("aa");
	if(clickflag == false)
	{
		clickflag = true;
		struct UsbInfo usb;
		QString Find;
		QString CurNum;
		QString UsbName;
		cur = listwidget->currentRow();
		CurNum.setNum(cur);
		UsbName = item->text() + CurNum;	
		if(FindUSBDevInfo.contains(UsbName))
		{
			Find =  FindUSBDevInfo.value(UsbName);
			usb = GetUsbInfo(Find.toAscii().data());
					 TotalCap.setNum(usb.TotalCapacity);
					 UsedCap.setNum(usb.UsedCapacity);
					 AvailableCap.setNum(usb.AvailableCapacity);
				
		   			USetInfo->setText( QString(kor("USB 장치 정보\n")) +QString(kor("전체 용량 : ")) + TotalCap  + QString("\n") + QString(kor("사용 중인 용량 : ")) + UsedCap + QString("\n")  + QString(kor("사용 가능한 용량 : ")) + AvailableCap + QString("\n") + QString(kor("마운트된 폴더 : ")) +  QString(usb.MountedPoint));
		 			USetInfo->setFrameStyle(QFrame::Box | QFrame::Sunken);
		 			USetInfo->setLineWidth(1);
		}
		clickflag = false;
	}
}
/*
     @brief USB 메모리 스틱의 장치 명 출력.
     @date 2009/10/07
     @author 안병기(sixthman23@naver.com)
*/
struct Widget::UsbInfo Widget::GetUsbInfo(char *devname)
{
 FILE *Info_fp = NULL;
 struct UsbInfo info;
 char InfoBuffer[256];
 char *ptr;
 int i = 0;
 char DevInfo1[256];
 memset(DevInfo1,0,sizeof(DevInfo1));
 sprintf(DevInfo1,"df %s",devname);
 memset(InfoBuffer,0,sizeof(InfoBuffer));
 if((Info_fp = popen(DevInfo1,"r")) == NULL)
  {
      perror("popen failed");
      exit(1);
  }
      sleep(1);
      fgets(InfoBuffer,sizeof(InfoBuffer),Info_fp); // 첫 번째 줄 Skip 하기 위함. 
	  while(fgets(InfoBuffer,sizeof(InfoBuffer),Info_fp)) // 지정된 장치만 사용 정보 출력.
	  {
			 ptr = strtok(InfoBuffer," ");
	         while(ptr != NULL)
			 {
	             ptr = strtok(NULL," ");
	             if(i == 0)
	                info.TotalCapacity = atoi(ptr);
	             if(i == 1)
	                info.UsedCapacity = atoi(ptr);
	             if(i == 2)
	                info.AvailableCapacity = atoi(ptr);
	             if(i == 4)
				 {
	               strcpy(info.MountedPoint,ptr);
				   MntInfo =  GetMountInfo(ptr);
				   qDebug(ptr);
				   MountedInfo.insert(QString(devname),QString(ptr));
				 }
	             	//info.MountedPoint = ptr;
					 i++;
	         }
		         ptr = NULL;
		  		 memset(InfoBuffer,0,sizeof(InfoBuffer));
	  }
	  pclose(Info_fp);
	  return info;
}
/*
 	@biref  USB 와 USB 간의 복사 루틴
	@param 목적파일,소스파일
	@return 복사 성공여
 */
int Thread::copyfile(const char *name1, const char *name2)
{
	qDebug("%s",name1);
	qDebug("%s",name2);
    
	
	SendNow = true;

	
	QFileInfo FileInfo(name1);

	int FileSize =  FileInfo.size();
	QString StrFileSize;
	StrFileSize.setNum(FileSize);
	qDebug("number:");
	qDebug(StrFileSize.toAscii());
	int infile, outfile;
 	int total = 0; 
    int progressnow = 0;
    double ing = 0;
   	ssize_t nread;
    char buffer1[BUFSIZE];
 
     if ((infile = open (name1, O_RDONLY )) == -1)
     {
		cout<< "return0" <<endl;

		 return (-1);
     }

	 if ((outfile = open (name2, O_WRONLY | O_CREAT |O_TRUNC, 0644)) == -1)
	 {
		 cout<< "return1" <<endl;

		 ::close(infile);
		 return (-2);
	 }
	 while(( nread = read(infile, buffer1, BUFSIZE)) >0)
	 {
		 qApp->processEvents();
		 if (write (outfile, buffer1, nread) < nread )
		 {
			 ::close(outfile);
			 return (-3);
		 }

		 total += nread;
		 QString number;
		 progressnow = (int)((total *100.0) / FileSize);
		 number.setNum(total);
		 emit SendPercent(progressnow,CurrentCount);
		 number.setNum(CurrentCount);

		 usleep(10000);
	 }
	 ::close(infile);
	 ::close(outfile);
	 QFileInfo fi(name2);
	 qDebug(fi.fileName().toAscii());
	 emit GetFinished("/"+fi.fileName());
	 CurrentCount++;

	 SendNow = false;
	 if ( nread == -1)
		 return (-4);
	 else
		 return (0);
}
