/**
* @class   MainWidget
* @data    2009/09/14
* @author  하지연(bssm16_hazi@naver.com)
* @brief   Main Widget
*/
#include <Qt>
#include <QPainter>
#include <QFrame>
#include <QListWidget>
#include <QListWidgetItem>
#include <QCheckBox>
#include <QTabWidget>
#include "./HeaderFile/wftpinterface.h"	// 플러그인 
#include "./HeaderFile/ReMakeInstance.h"// 객체 재 정의 
#include "./HeaderFile/ConsDefine.h"	// 상수 Define
#include "./trackdelegate.h"
#include <QDir>
#include <QList>
#include <QLineEdit>
#include <QStringList>
#include <QIcon>
#include <QHash>
#include <QSizePolicy>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
 #include <string.h>
 #include <iostream>


#define BUFSIZE 512
#define PERM 0644

#define kor(str) QString::fromUtf8(str)	//한국어 사용 유니코드지원 

class WFTPInterface;
class FTPSetInterface;
class SetBlueInterface;
class FTPSettingInterface;
class NewPushButton;
class TrackDelegate;
class TorrentViewDelegate;
class Thread;

//로컬 파일 교환 스레드 클래스
class Thread : public QThread
{
	Q_OBJECT
	public:
		Thread();
		QString dest;
		QWidget *m_pParent;
		QString source;
		void stop();
		void run();
		int copyfile(const char *name1, const char *name2);

		QLinkedList<QString>FileWaitList;
		QMutex mutex;
		bool SendNow;
		int CurrentCount;
	signals :
		void SendPercent(int,int);
		void GetFinished(QString);
		void GetWaited(QString);
	
	public:
		QString messageStr;
		volatile bool stopped;
};

//메인 UI 구성을 위한 위젯 클래스
class Widget : public QWidget
{
	Q_OBJECT

	public :
//		QWidget* ViewFtpWid; //ftp 접속 설정 화면 위젯	
	public :
		Widget();
		int listpos;
		//void stateWidget();     //통신 상태확인 함수
		void firstWidget();     // Main Widget 1
		void secondWidget();    // Main Widget 2
		void thirdWidget();     // Main Widget 3
		void fourthWidget();    // Main Widget 4
		void fifthWidget();     // Main Widget 5

		void ButtonWidget();    // Main Button
		void UnderButtonWidget();	//하위 장치 Setting에 들어오게 되면

		void USBSettingWidget();    //USB Setting버튼 클릭시 수행하는 위젯
		void GetProgressFileInfo(QString, QString , QString ,int);
		int getTestResult;
		int getProgressState;
		int getProgressInfo();
		int getProgressValue();
	public slots:
//	    void ViewConnectFtp(); // ftp 화면 전환

	private :
//	    void ViewFtpWidget(); // 화면 디스플레이
	                      
	signals:
		void ButtonCount(int index);

	public :
		QWidget *FifthWidget;
		         QTreeWidgetItem *itemTest1;
		          QTreeWidget *LoadView;

	public slots:
				// Main화면에서 존재하는 하단 버튼 클릭시 Main화면 변경 
				void ChangeMain1Widget();
				void ChangeMain2Widget();
				void ChangeMain3Widget();
				void ChangeMain4Widget();
				void ChangeMain5Widget();

				void UpLoadFunction();
				void DownLoadFunction();
				void TempotaryStop();	//일시정지 버튼 5Page
				
				void update();
				
				//하위 화면
				void USBSettingRecevie();

				void itemDelete(QTreeWidgetItem *);
				void ListDelete();	//마우스 이벤트 클릭시 해당 리스트 지우기
				
	private :
				//Start of Plugin  
				//Plugin의 so 파일을 해당 디렉토리에서 찾는다. -------
				bool loadPlugins();
				bool FTPloadPlugins();
				bool SetbluePlugins();
				bool FTPSettingPlugins();
				static QDir directoryOf(const QString &subdir);
				WFTPInterface *wftpInterface;
				FTPSetInterface *FTPInterface;
				SetBlueInterface *SetBInterface;
				FTPSettingInterface *FtpsettingInterface;
				int ReturnValue;
				int ButtonReturnValue;
				//End of Plugin -------------------------------------
		
				TorrentViewDelegate *TestProgress;
				//----- State & Layout등록 -----	
				QVBoxLayout *VBoxLayout;
				QStackedLayout *StateHBoxLayout;
				QHBoxLayout *ButtonHBoxLayout;
				QStackedLayout *StackedLayout;
				QStackedLayout *ButtonStiacked;	

				//----- Main Button-----
				QWidget *buttonWidget;
				QLabel *StateData;
				QPushButton* PushButton;
		        QPushButton* PushButton2;
		        QPushButton* PushButton3;
		        QPushButton* PushButton4;
			    QPushButton* PushButton5;
				QPushButton *CancelButton;

				//----- Under1Button
				QWidget *button1Widget;
				QHBoxLayout *Button1HBoxLayout;
				QPushButton *Push1Button;
				QPushButton *Push2Button;
				QPushButton *Push3Button;

//----------- Widget 구성 ------------------------------
				QWidget *StateWidget;
				//----- First Widget -----
				QWidget *FirstWidget;
				//QLabel *MainImage;
				//----- Second Widget -----
				QWidget *SecondWidget;
				QVBoxLayout *SetVBoxLayout;
				QLabel *MainSetLabel;
				NewPushButton *USetButton;
				//---- Third Widget -----
				QWidget *ThirdWidget;
				QVBoxLayout *FTPVBoxLayout;
				QLabel *MainFTPLabel;
				//---- Fourth Widget -----
				QWidget *FourthWidget;
				QVBoxLayout *TransVBoxLayout;
				QHBoxLayout *BtHBoxLayout;
				QTreeWidget *UpTreeWidget;
				QTreeWidget *DownTreeWidget;
				QTreeWidgetItem *Item1;
				QTreeWidgetItem *Item2;
				QPushButton *UpLoadButton;
				
				QVBoxLayout *FVBoxLayout;
				QHBoxLayout *FHBoxLayout;
				QPushButton *FPushButton;
				QPushButton *FPushButton1;
				QPushButton *FPushButton2;
				QPushButton *FPushButton3;
				int TempotaryStopFlag;
				int TreeIndexforDelete;
				
				//----- USB Setting ------
				QWidget *USBCreateWidget;
				QVBoxLayout *UCreateVBoxLayout;
				QLabel *UCreateLabel;
				QListWidget *listwidget;
				QFrame *USetInfoFrame;
				QLabel *USetInfo;
			
				char File1[100];
				char File2[100];	
				
				
							// @athor 안병기(sixthman23@naver.com) 사용 변수,함수  	
				struct UsbInfo
				{
					long TotalCapacity; //전체 용량
					long UsedCapacity;  // 사용 중인 용량
				    long AvailableCapacity; // 이용 가능한 용량
				    char *MountedPoint; // 마운트된 폴더명
				};
				// FILE *read_fp; // 노드 여부 검사위한 파이프
			    // FILE *find_fp; // 장치명 검사를 위한 파이프
			     char buffer[256];
			     char udevopen[256];
			     char FindForDeviceName[256];
			     char *Modelresult;
			     char *Vendorresult;
			     char temp1[256];
			     char temp2[256];
			     char DeviceName[256];
				 char devinfo[256];
				 char tempDev[256];
				 bool clickflag;
				 bool delflag;
				 int delcnt;
				 int cur; //선택된 리스트 박스 아이템 번호 
				 //QString Find;
				 //QString CurNum;
	public: 
				 QString TotalCap;
				 QString UsedCap;
				 QString AvailableCap;
				 //QString UsbName;
				 QString RemoveUsb;
				 QString MntInfo;
				 QListWidgetItem rmitem;
				 QTreeView *DownloadView;
				 QDirModel *DownloadModel;
				 QDir* Listdir;	  
				 struct UsbInfo GetUsbInfo(char *devname);
                 struct UsbInfo usb1;
                 
				char* GetUSBModelName(char* target ,char *message);
				QHash<QString,QString>FindUSBDevInfo;
				QHash<QString,QString>MountedInfo;
				QHash<QString,QString>PathInfo;
				QHash<QString,QString>DownPathInfo;
				QHash<QString,QString>UpFolderInfo;
				QHash<QString,QString>FolderInfo;
				QHash<QString,QString>*FtpFileInfo;
				QString GetMountInfo(char*  mntinfo);
				void GetUSBInfo();
				char* FileViewInfo(char *devname);
			
				void HasChildren(QString);
				QString rootPath(QTreeWidgetItem *item);
				QTreeWidgetItem* createTreeWidgetItem(QTreeWidgetItem *parent, const QStringList &path);
				QString pathTo(QTreeWidgetItem *item, QTreeWidgetItem *parent);
				QString rootPathForWlan(QTreeWidgetItem *item);
	public slots:
				void GetUSBInformation(QListWidgetItem* item);
	            void GetUsbInFileInfo(QTreeWidgetItem* item);
			   	void DownloadItem(QTreeWidgetItem* item);
				void RemoveUSBDevice();
				void SendPercent(int,int);
				void GetFinished(QString);	
				void GetWaited(QString);
	public:
					QTreeWidgetItem *PresentItem;
					QString SelectedForDownload;
					QString SelectedForUpload;
					Thread *CopyThread;
                    QString copytarget;
					char DeviceType[100];	
					int RowIndex();
					int sumFunction();
					int countButton;
					int IndexRowWidget;
					int sending;
					int itemListCount;	
					int countTest;
					bool IsFinished;
					bool SetUsbNum1; // usb 장치의 폴더,파일 선택시 셋됨.
					bool SetUsbNum2; // usb 장치의 폴더, 파일 선택시 셋됨.
					bool SetWireless; // wlan 장치의 폴더, 파일 선택시 셋됨.
				    QString FirstDevice; // 첫 번째로 선택된 디바이스.
					QString SecondDevice; // 두 번째로 선택된 디바이스. 	 
};
// 파일 전송 현황 표시를 위한 progress bar 상태 갱신을 위한 클래스
class TorrentViewDelegate : public QItemDelegate
{
     Q_OBJECT
   public:
      TorrentViewDelegate(Widget *parent) : QItemDelegate(parent) {}
	  void paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index )const
	  {
		int indexRow =  qobject_cast<Widget *>(parent())->RowIndex();
		int sum = qobject_cast<Widget *>(parent())->sumFunction();

	qDebug("i%d----%d-----%d-----%d", index.column(),index.row(), indexRow, sum);	
//	if (index.column() != 4 || index.row() != indexRow || progress != 1) {
	if (index.column() != 4 || indexRow != 1 || index.row() != sum) {
		//컬럼이 4이고,상태 체크, 실행중인 Row 번지. 	
			qDebug("cant make delegate");
			 return QItemDelegate::paint(painter, option, index);
		
	}
// 내가 사용하고 있는 row 데이터 값을 가지고 오면 그게 끝난경우 flag받아서 
// 
			qDebug("Sending");
     		
			QStyleOptionProgressBar progressBarOption;
			progressBarOption.state = QStyle::State_Enabled;
	        progressBarOption.direction = QApplication::layoutDirection();
	        progressBarOption.rect = option.rect;
		    progressBarOption.fontMetrics = QApplication::fontMetrics();	
   			progressBarOption.minimum = 0;
	        progressBarOption.maximum = 100;
	        progressBarOption.textAlignment = Qt::AlignCenter;
	        progressBarOption.textVisible = true;

			int	progress = qobject_cast<Widget *>(parent())->getProgressInfo();
			progressBarOption.progress = progress < 0 ? 0 : progress;
			progressBarOption.text = QString().sprintf("%d%%", progressBarOption.progress);
			QApplication::style()->drawControl(QStyle::CE_ProgressBar, &progressBarOption, painter);
	  }
};

