// Setting Bluetooth Plugin 부분이다.
#ifndef SETBLUEPLUGIN_H
#define SETBLUEPLUGIN_H

#include "../HeaderFile/wftpinterface.h"
#include "../HeaderFile/ReMakeInstance.h"
#include "../HeaderFile/ConsDefine.h"

class NewPushButton;
class SetBluePlugin : public QObject, public SetBlueInterface
{
	Q_OBJECT
	Q_INTERFACES(SetBlueInterface)

	public :
		int WidgetValue;
		int ButtonLayoutValue;

		//Layout Return Function
		void SetLayoutSender(QStackedLayout *WidgetLayout);
		void SetButtonLayoutSender(QStackedLayout *ButtonLayout);

		//Widget Display
		int BlueSetButton(QVBoxLayout *layout, int widgetvalue);
		void SetBlueWidget(QStackedLayout *layout);
		void SetNewBlueWidget(QStackedLayout *layout);
		void RegisterBlueWidget(QStackedLayout *layout);
		void PinCodeWidget(QStackedLayout *layout);

		//Button Widget
		int SetBluetoothButton(QStackedLayout *Buttonlayout, int buttonvalue);
		void SetBlueNewButton(QStackedLayout *Buttonlayout);
		void SetBlueRegisterButton(QStackedLayout *Buttonlayout);
		void SetBluePinButton(QStackedLayout *Buttonlayout);
	
	public slots :
		//Move to Widget()
		void SetBluePage();
		void SetNewBluePage();
		void RegisterBluePage();
		void GotoMain();
		void BackKey();
		void PinCodePage();

		//Event Function()
		void Use4Blue(); //블루투스 사용 및 해제	
		void ReSearch();
		void NewSearch();

	private :
		int Use4BlueCount;
		int SearchCount;
		int ReSearchCount;
		
		QStackedLayout *SetBlueLayout;
		QStackedLayout *SetButtonLayout;

		//BlueSetButton()
		NewPushButton *BlueSetAddButton;

		//SetBlueWidget()
		QWidget *BlueWidget;
		QVBoxLayout *SetBlueVLayout;
		QLabel *SetBlueLabel;
		QListWidget *BlueListWidget;
		QPushButton *NewSearchButton;
		QPushButton *HavenButton;

		//SetNewBlueWidget()
		QWidget *NewBlueWidget;
		QVBoxLayout *SetNewVLayout;
		QLabel *NewBlueLabel;
		QListWidget *NewBlueListWidget;
		QLabel *NewBlueInfo;

		//PinCodeWidget()
		QWidget *PinWidget;
		QVBoxLayout *PinVLayout;
		QLabel *PinLabel;
		QLabel *PinEntry;
		QLineEdit *PinEdit;

		//RegisterBlueWidget()
		QWidget *RegisterWidget;
		QVBoxLayout *RegisterVLayout;
		QLabel *RegisterBlueLabel;
		QListWidget *RegisterBlueListWidget;
		QLabel *RegisterBlueInfo;

		//SetBluetoothButton()
		QWidget *BlueButtonWidget;
		QPushButton *Main;
		QPushButton *SelectButton;
		QPushButton *Use4BlueButton;	//블루투스 사용 버튼 
		QPushButton *BackButton;
	
		//SetBlueNewButton()
		QWidget *NewButtonWidget;
		QHBoxLayout *Button3HBoxLayout;
		QPushButton *NewMain;
		QPushButton *NewSelectButton;
		QPushButton *ReSearchButton;
		QPushButton *NewBackButton;

		//SetBlueRegisterButton()
		QWidget *RegisterButtonWidget;
		QHBoxLayout *Button4HBoxLayout;
		QPushButton *RegisterMain;
		QPushButton *RegisterCancelButton;
		QPushButton *RegisterConnectButton;
		QPushButton *RegisterBackButton;

		//SetBluePinButton()
		QWidget *PinButtonWidget;
		QHBoxLayout *Pin4HBoxLayout;
		QPushButton *PinMain;
		QPushButton *PinCancelButton;
		QPushButton *PinBackButton;

		
};

#endif
