/**
		@file 	handler.h
		@date	
		@author	최영업(cyu0070@naver.com) Terapi
		@brief		
*/

#ifndef __HANDLER_H_
#define __HANDLER_H_
using namespace std;

#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <sys/stat.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <iostream>
#include <ctype.h>
#include <time.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <errno.h>
#define INVALID_SOCKET -1

#include "clientmanager.h"
#include "ftpcommand.h"
#include "receiver.h"
#include <QtGui>
#include <QApplication>
/**
	@class	Handler
	@date   2009/08/24
	@author	최영업(cyu0070@naver.com) Terapi
	@brief	client에서 사용될 명령어 처리부분
*/

#define REQ_COUNT 27
#define USR_USER   0
#define USR_PASS   1
#define USR_ONLINE 2



class Handler  : public QObject
{
   Q_OBJECT

    signals:
		void test(int);	
   		void Send_Dir(QString);
	public:
		void  do_ascii(int,int);
		int  do_account(int, int); ///<자원에 대한 액세스 권한을 부여하기 전에 원격 호스트에 필요한 보조 암호를 송신합니다. 이 명령에 암호가 제공되지 않으면, 사용자에게 암호를 요청하는 프롬프트가 표시됩니다. 암호는 화면에 표시되지 않습니다.
		int  do_append(int, int);  ///<국지 파일을 원격 호스트의 파일에 추가합니다.
		int  do_bell (int, int);	///<각 파일 전송 완료후 벨을 울립니다.
		int  do_bye (int, int); ///<파일 전송 세션을 끝내고 ftp명령을 종료합니다. quit 부속 명령과 동일합니다.
		
		
		int  do_cd (int, char*, int ); ///< 원격 HOST의 작업 DIRECTORTY 를 지정된 DIRECTORTY로 변경합니다.
		int  do_cdup (int, int); ///< 원격 HOST의 작업 DIRECTORTY를 현재	DIRECTORTY의 상위 DIRECTORY 로 변경합니다.

		int  do_chmod (int, int); ///< 국지파일의 파일모드를 변경합니다.
		int  do_close (int, int); ///< 파일 전송 세션은 끝내지만 ftp 명령은 종료하지 않습니다. 정의된 매크로는 삭제됩니다. disconnect 부속 명령과 동일합니다.
 int	/*	struct Dir_Info_arr */ do_dir(int,char*, int, pthread_mutex_t); ///<지정된 원격 디렉토리(RemoteDirectory)의 내용 리스트를 지정된 국지 파일(LocalFile)에 기록합니다.
		int  do_disconnect (int, int); ///<파일 전송 세션은 끝내지만 ftp 명령은 종료하지 않습니다. 정의된 매크로는 삭제됩니다. close 부속 명령과 동일합니다.
		int  do_delete (int, char*); ///< 지정된 원격 파일을 삭제합니다.


		int  do_get (int, char*, char*, pthread_mutex_t); ///<원격 파일을 국지 호스트에 복사합니다

		void do_help (void); ///<도움말 정보를 표시합니다.
		int  do_ls (int, int); ///<원격 디렉토리의 약식 파일 리스트를 국지 파일에 기록합니다. 
		int  do_mdir(int, int); ///< 원격 호스트에서 RemoteDirectories 매개변수가 지정하는 디렉토리를 확장하고, 
							   ///< 그 디렉토리의 내용 리스트를 LocalFile 매개변수에서 지정한 파일에 기록합니다.  
		int  do_mget(int, char*);///< 원격 호스트에서 RemoteFiles 매개변수를 확장하고 표시된 원격 파일을 국지 호스트에서 현재 디렉토리에 복사합니다.
		int  do_mkdir (int, char*);///< 원격 호스트에 RemoteDirectory 매개변수에서 지정한 디렉토리를 작성합니다.
		int  do_modtime (int, int);///< 원격 기계에서 지정된 파일의 최종 수정 시간을 표시합니다.
		int  do_mput (int, int); ///< 국지 호스트에서 LocalFiles 매개변수가 지정하는 파일을 확장하고 지정된 국지 파일을 원격 호스트에 복사합니다. 
		int  do_open (int, int); ///< HostName 매개변수가 지정한 호스트에서 FTP 서버에 대한 연결을 설정합니다.

		int  do_pass 	( int, char* );///< 사용자가 userid 입력후 pass을 입력하여서 확인하는 함수

		
		int  do_put (int, char*, char*, pthread_mutex_t); ///하나의 파일을 remote시스템에 올린다
		
			
		void do_pwd (int, int); ///<remote시스템의 현재 작업디렉토리를 표시한다remote시스템의 현재 작업디렉토리를 표시한다
		void do_quit (int, int); ///<연결을 닫고 ftp 명령을 종료합니다. bye 부속 명령과 동일합니다.
		int  do_recv (int, int); ///<원격 파일을 국지 호스트에 복사합니다. get 부속 명령과 같습니다
		int  do_rename (int); ///<
		int  do_rmdir   (int, char*); ///< 원격 호스트에서 RemoteDirectory 매개변수가 지정하는 원격 디렉토리를 제거
	
		int  do_size (int, char*); ///< 해당파일의 파일크기를 호출합니다.
		int  do_mdtm (int, char*);///< 파일의 마지막 변경시간 출력.
		int  do_status (int); ///<
		int  do_system (int, int); ///< 원격 기계에서 실행 중인 운영 시스템의 유형을 표시합니다.



		int do_user(int, char *);

		void kill_connection(  int);
		void handle_suspects(void);
		void handle_timeout (  int);

};



#endif
