/**
		@file 	clientmanager.cpp
		@date	2009/08/10	
		@author	최영업(cyu0070@naver.com) Terapi
		@brief	클라이언트에서 사용하는 명령어를 분기하는 파일 		
*/

#include "clientmanager.h"

const char *CLIENT_PROMPT="*DEN_ftp> ";

int ClientManager::s_cli_state =USR_USER;
bool ClientManager::s_DaemonMode = 0;

ClientManager::ClientManager(){}

void ClientManager::set_sock(int m_sock)
{
	this->m_sock = m_sock;
}
void ClientManager::out_prompt(void)
{
	cout << CLIENT_PROMPT  ;
	fflush(stdout);
}

int ClientManager::Client_cmd(int sock,char* dir_buffer,char *cmd,pthread_mutex_t cmutex)	///<클라이언트의 명령어 분기를 위한 함수
{
	FtpCommand fc;
	Handler hn;

	char* real_path = new char[1024];
	memset(real_path,0,1024);
	strcpy(real_path,"/home/b/");
	
	char *param= new char[1024];
	int rc =0;

	if (strlen(cmd)<2) 
		return -1;
	
	for (rc=0; rc<strlen(cmd); rc++)
		if (cmd[rc]==' ') 
			break;

	if (cmd[rc]==' ')
	{
		cmd[rc]=0;
		param=cmd+rc+1;
	}

	for (rc=0;rc<strlen(cmd);rc++)
		cmd[rc]=tolower(cmd[rc]);

	for (rc=0;rc<73;rc++)
		if (!strcmp(fc.command[rc],cmd)) 
			break;

	switch(rc)
	{
		//case REQ_debug:		/*0*/
		//		break;
		case REQ_mdir:			/*1*/
			break;
		//case REQ_qc	:		/*2*/
		//		break;
		case REQ_send:			/*3*/
			break;
		case REQ_dir:			/*4*/
			hn.do_dir(sock,dir_buffer,rc,cmutex);
			break;
		case REQ_mget:			/*5*/	
			break;
		//	case REQ_sendport: 	/*6*/
		//		break;
		//	case REQ_site:		/*7*/
		//		break;
		case REQ_account:	/*8*/
			break;
		//	case REQ_disconnect:/*9*/
		//		break;
		case REQ_mkdir:		/*10*/
			hn.do_mkdir(sock,param);
			break; 
		case REQ_put:		/*11*/
			hn.do_put(sock,param,real_path,cmutex);
			break; 
		//	case REQ_size:		/*12*/
		//		break; 
		case REQ_append:	/*13*/
			break; 
		case REQ_exit:		/*14*/
			break; 
		case REQ_mls:		/*15*/
			break; 
		case REQ_pwd:		/*16*/	
			hn.do_pwd(sock,rc);
			break; 
		//	case REQ_status:	/*17*/
		//		break; 
		case REQ_ascii:		/*18*/
			hn.do_ascii(sock,rc);
			break; 
		//	case REQ_form:		/*19*/
		//		break;
		//	case REQ_mode:		/*20*/
		//		break; 

		case REQ_quit:		/*21*/	
			hn.do_quit(sock,rc);
			break; 
		//	case REQ_struct:	/*22*/	
		//		break; 
		//	case REQ_bell:		/*23*/	
		//		break; 
		case REQ_get:		/*24*/
			hn.do_get(sock, param, real_path ,cmutex);
			break; 
		//	case REQ_modtime:	/*25*/
		//		break; 
		//	case REQ_quote:		/*26*/
		//		break; 
		//	case REQ_system:	/*27*/
		//		hn.do_system(sock,nr);
		//		break; 

		case REQ_binary:	/*28*/
			break; 
		//	case REQ_glob:		/*29*/
		//		break;
		case REQ_mput:		/*30*/	
			break; 
		case REQ_recv:		/*31*/
			break; 
		//	case REQ_sunique:	/*32*/
		//		break; 
		case REQ_bye:		/*33*/
			hn.do_quit(sock,REQ_quit);
			break; 
		//	case REQ_hash:		/*34*/
		//		break; 
		//	case REQ_newer:		/*35*/	
		//	break; 
		case REQ_reget:		/*36*/	
			break; 
		//	case REQ_tenex:		/*37*/
		//		break; 
		//	case REQ_case:		/*38*/
		//		break; 

		case REQ_help:		/*39*/
			hn.do_help();
			break;

		//	case REQ_nmap:		/*40*/	
		//		break; 
		//	case REQ_rstatus:	/*41*/	
		//		break; 
		//	case REQ_tick:		/*42*/
		//		break; 
		case REQ_cd:		/*43*/	
			hn.do_cd(sock,param,rc);
			break; 
		//	case REQ_idle:		/*44*/
		//		break; 
		//	case REQ_nlist:		/*45*/	
		//		break; 
		//	case REQ_rhelp:		/*46*/	
		//		break; 
		//	case REQ_trace:		/*47*/
		//		break; 
		//	case REQ_cdup:		/*48*/
		//		break; 
		//	case REQ_image:		/*49*/
		//	break;
		//	case REQ_ntrans:	/*50*/	
		//	break; 
		case REQ_rename:	/*51*/
			hn.do_rename(sock);
			break; 
		//	case REQ_type:		/*52*/
		//		break; 
		//	case REQ_chmod:		/*53*/
		//		break; 
		//	case REQ_lcd:		/*54*/
		//		break; 
		//	case REQ_open:		/*55*/	
		//		break; 
		//	case REQ_reset:		/*56*/	
		//		break; 
		//	case REQ_user:		/*57*/	
		//		break; 
		//	case REQ_close:		/*58*/
		//		break; 
		case REQ_ls:		/*59*/
			hn.do_ls(sock,rc);
			break;
		//	case REQ_prompt:	/*60*/
		//		break; 
		//	case REQ_restart:	/*61*/	
		//		break; 
		//	case REQ_umask:		/*62*/
		//		break; 
		//	case REQ_cr:		/*63*/	
		//		break; 
		//	case REQ_macdef:	/*64*/
		//		break; 
		//	case REQ_passive:	/*65*/
		//		break; 
		case REQ_rmdir:		/*66*/	
			hn.do_rmdir(sock,param);
			break; 
		//	case REQ_verbose:	/*67*/
		//		break; 
		case REQ_delete:	/*68*/
			hn.do_delete(sock,param);
			break; 
		//	case REQ_mdelete:	/*69*/
		//		break;
		//	case REQ_proxy:		/*70*/
		//		break;
		//	case REQ_runique:	/*71*/
		//		break;
		//
		default:
			cout <<"default command"<<endl;
			break;

	}
	
	delete [] real_path;
	// delete []param;

	return 0;
}


