/**
		@file 	accepter.cpp
		@date	2009/08/23
		@author	최영업(cyu0070@naver.com) Terapi
		@brief	서버의 접속후 해당 소켓을 알기위한 함수	
*/

#include "connecter.h"

/**
	@return 클라이언트가 서버에 접속후에 소켓정보를 반환 
	@warning
  */

int Connecter::serverconnecter(char* ser_ip,char* ser_port) ///< 서버에 접속
{

	int sock;
	ClientManager cm;
	
	cm.set_sock(socket(PF_INET, SOCK_STREAM, 0) ); //소켓 생성 및  클래스멤버변수에 세팅

	try{	

		struct sockaddr_in serv_addr;

		if(cm.get_sock() == -1)
			throw "socket() error";

		memset(&serv_addr, 0, sizeof(serv_addr));
		serv_addr.sin_family=AF_INET;
		serv_addr.sin_addr.s_addr=inet_addr(ser_ip);	//아이피
		serv_addr.sin_port=htons(atoi(ser_port));		//포트 세팅
		if( connect(cm.get_sock(), (struct sockaddr*)&serv_addr, sizeof(serv_addr))==-1 ) 
			throw "connect() error";
	}
	catch(char *errmsg) 
	{
		cout << errmsg <<endl;
	}
	return cm.get_sock();
}
