/**
		@file 	ftpclient.cpp
		@date	2009/08/10	
		@author	최영업(cyu0070@naver.com) Terapi
		@brief	클리이언트의 실행을 맡고있므며 클라이언트의 프로토콜세팅 및 ID,PASSWD등 초기설정을 담당	
*/

#include "ftpclient.h"

bool  FtpClient::s_Client_Stop=0;
char* FtpClient::ip=0;

/**
 	@return 실패 -1
			성공 0
 */

fd_set fds;
ClientManager cm;
Handler hn;

char param[20];
char c_cmd[1024];

struct timeval c_tv;
int c_i=0,c_n=0,rc=0;



int FtpClient::Run(int sock,char*dir_buffer,char* id,char*pw,pthread_mutex_t cmutex)
{

	FD_ZERO(&fds);
	FD_SET(1,&fds);
	FD_SET(0,&fds);


	if(ClientManager::s_cli_state == USR_ONLINE)
	{
		c_tv.tv_sec=60;
		c_tv.tv_usec=0L;
//		sleep(1);
		c_n=select(1000,&fds,NULL,NULL,&c_tv);
		//sleep(1);
		if (c_n<0) 
		{
			if (errno==EINTR)
			{
				return -2;
			}
			c_i=(int)errno;
			fprintf(stderr,"*** Fehler: select (ret: %d,errno=%d).\n",c_n,c_i);
			return -1;
		}

		if (FD_ISSET(1,&fds))
		{
			c_i=read(1,c_cmd,sizeof(c_cmd)); ///< 서버에서 받은 명령어
			if (c_i<1) 
			{
				return -2;
			}

			c_cmd[c_i-1]=0;

			cm.Client_cmd(sock,dir_buffer,c_cmd,cmutex);

			if (FtpClient::s_Client_Stop) 
			{
				return 0;
			}
			cm.out_prompt();
		}
	}
	else
	{
		if(ClientManager::s_cli_state == USR_USER)
		{
			hn.do_user(sock,id);
			ClientManager::s_cli_state = USR_PASS;
		}
		else if(ClientManager::s_cli_state == USR_PASS)
		{
			hn.do_pass(sock,pw);
			ClientManager::s_cli_state = USR_ONLINE;
//			hn.do_dir(sock,2,cmutex);
			cm.out_prompt();
		}
	}
}
//메인문
int FtpClient::Client_Start(char* ip)
{
	int sock;
	
	Connecter cn;
	ClientManager cm;
	memset (param,0,20);
	memset (c_cmd,0,1024);
	
	
	char t_port[4];
	itoa(21,t_port,10);


	cm.set_sock(cn.serverconnecter(ip,t_port));
	
	FtpClient::ip = new char[strlen(ip)+1];
	strcpy(FtpClient::ip,ip);

//	int sock1 = 	// 소켓 할당 및 연결을 마친후 해당하는 소켓 값을 가지고 
	// 클라이언트를 동작하면서 받아드린 명령어 보내질 명령어에 대하여서 처리함.

	
	return cm.get_sock();
// sock1;
}



