/**
		@file 	ftpcommand.h
		@date	2009/08/19
		@author	최영업(cyu0070@naver.com) Terapi
		@brief	client의 명령어를 선언한 파일
*/

#ifndef __FTPCOMMAND_H_
#define __FTPCOMMAND_H_
using namespace std;
#include <iostream>
#include <string.h>

enum ftpcmd{  
	REQ_debug=0,	REQ_mdir,	  	REQ_qc,		REQ_send,	REQ_dir,
	REQ_mget,		REQ_sendport, 	REQ_site,	REQ_account,REQ_disconnect,

	REQ_mkdir=10,	REQ_put,		REQ_size,	REQ_append,	REQ_exit,
	REQ_mls,		REQ_pwd,		REQ_status,	REQ_ascii,	REQ_form,

	REQ_mode=20,	REQ_quit,		REQ_struct,	REQ_bell,	REQ_get,
	REQ_modtime,	REQ_quote,		REQ_system,	REQ_binary,	REQ_glob,

	REQ_mput,		REQ_recv,		REQ_sunique,REQ_bye,	REQ_hash,
	REQ_newer,		REQ_reget,		REQ_tenex,	REQ_case,	REQ_help,
	REQ_nmap,		REQ_rstatus,	REQ_tick,	REQ_cd,		REQ_idle,
	REQ_nlist,		REQ_rhelp,		REQ_trace,	REQ_cdup,	REQ_image,
	REQ_ntrans,		REQ_rename,		REQ_type,	REQ_chmod,	REQ_lcd,
	REQ_open,		REQ_reset,		REQ_user,	REQ_close,	REQ_ls,
	REQ_prompt,		REQ_restart,	REQ_umask,	REQ_cr,		REQ_macdef,
	REQ_passive,	REQ_rmdir,		REQ_verbose,REQ_delete,	REQ_mdelete,
	REQ_proxy,		REQ_runique, 	REQ_e
};
#define REQ_SYST 0
#define REQ_QUIT 1
#define REQ_TYPE 2
#define REQ_PORT 3
#define REQ_LIST 4
#define REQ_CWD  5
#define REQ_PWD  6
#define REQ_RETR 7
#define REQ_USER 8
#define REQ_PASS 9
#define REQ_REST 10
#define REQ_SIZE 11
#define REQ_MDTM 12
#define REQ_STOR 13
#define REQ_CDUP 14
#define REQ_NOOP 15
#define REQ_GET  16
#define REQ_NLST 17
#define REQ_PASV 18
#define REQ_ABOR 19
#define REQ_MKD  20
#define REQ_RMD  21
#define REQ_DELE 22
#define REQ_RNFR 23
#define REQ_RNTO 24
#define REQ_APPE 25
#define REQ_STOU 26


#define Command_Count 73


class FtpCommand		
{
	public:

		char *request[27];
		char *command[73];

		FtpCommand()
		{
			command[0]  = new char[sizeof("debug")+1];		strcpy(command[0]  ,"debug");
			command[1]  = new char[sizeof("mdir")+1]; 		strcpy(command[1]  ,"mdir");
			command[2]  = new char[sizeof("qc")+1];	  		strcpy(command[2]  ,"qc");
			command[3]  = new char[sizeof("send")+1]; 		strcpy(command[3]  ,"send");
			command[4]  = new char[sizeof("dir")+1]; 		strcpy(command[4]  ,"dir");
			command[5]  = new char[sizeof("mget")+1]; 		strcpy(command[5]  ,"mget");
			command[6]  = new char[sizeof("sendport")+1];	strcpy(command[6]  ,"sendport");
			command[7]  = new char[sizeof("site")+1]; 		strcpy(command[7]  ,"site");
			command[8]  = new char[sizeof("account")+1]; 	strcpy(command[8]  ,"account");
			command[9]  = new char[sizeof("disconnect")+1];	strcpy(command[9]  ,"disconnect");
			command[10] = new char[sizeof("mkdir")+1]; 		strcpy(command[10] ,"mkdir");
			command[11] = new char[sizeof("put")+1]; 		strcpy(command[11] ,"put");
			command[12] = new char[sizeof("size")+1]; 		strcpy(command[12] ,"size");
			command[13] = new char[sizeof("append")+1]; 	strcpy(command[13] ,"append");
			command[14] = new char[sizeof("exit")+1]; 		strcpy(command[14] ,"exit");
			command[15] = new char[sizeof("mls")+1]; 		strcpy(command[15] ,"mls");
			command[16] = new char[sizeof("pwd")+1]; 		strcpy(command[16] ,"pwd");
			command[17] = new char[sizeof("status")+1]; 	strcpy(command[17] ,"status");
			command[18] = new char[sizeof("ascii")+1]; 		strcpy(command[18] ,"ascii");
			command[19] = new char[sizeof("form")+1]; 		strcpy(command[19] ,"form");
			command[20] = new char[sizeof("mode")+1]; 		strcpy(command[20] ,"mode");
			command[21] = new char[sizeof("quit")+1]; 		strcpy(command[21] ,"quit");
			command[22] = new char[sizeof("struct")+1]; 	strcpy(command[22] ,"struct");
			command[23] = new char[sizeof("bell")+1]; 		strcpy(command[23] ,"bell");
			command[24] = new char[sizeof("get")+1]; 		strcpy(command[24] ,"get");
			command[25] = new char[sizeof("modtime")+1]; 	strcpy(command[25] ,"modtime");
			command[26] = new char[sizeof("quote")+1]; 		strcpy(command[26] ,"quote");
			command[27] = new char[sizeof("system")+1]; 	strcpy(command[27] ,"system");
			command[28] = new char[sizeof("binary")+1]; 	strcpy(command[28] ,"binary");
			command[29] = new char[sizeof("glob")+1]; 		strcpy(command[29] ,"glob");
			command[30] = new char[sizeof("mput")+1]; 		strcpy(command[30] ,"mput");
			command[31] = new char[sizeof("recv")+1]; 		strcpy(command[31] ,"recv");
			command[32] = new char[sizeof("sunique")+1]; 	strcpy(command[32] ,"sunique");
			command[33] = new char[sizeof("bye")+1]; 		strcpy(command[33] ,"bye");
			command[34] = new char[sizeof("hash")+1]; 		strcpy(command[34] ,"hash");
			command[35] = new char[sizeof("newer")+1]; 		strcpy(command[35] ,"newer");
			command[36] = new char[sizeof("reget")+1]; 		strcpy(command[36] ,"reget");
			command[37] = new char[sizeof("tenex")+1]; 		strcpy(command[37] ,"tenex");
			command[38] = new char[sizeof("case")+1]; 		strcpy(command[38] ,"case");
			command[39] = new char[sizeof("help")+1]; 		strcpy(command[39] ,"help");
			command[40] = new char[sizeof("nmap")+1]; 		strcpy(command[40] ,"nmap");
			command[41] = new char[sizeof("rstatus")+1]; 	strcpy(command[41] ,"rstatus");
			command[42] = new char[sizeof("tick")+1]; 		strcpy(command[42] ,"tick");
			command[43] = new char[sizeof("cd")+1]; 		strcpy(command[43] ,"cd");
			command[44] = new char[sizeof("idle")+1]; 		strcpy(command[44] ,"idle");
			command[45] = new char[sizeof("nlist")+1]; 		strcpy(command[45] ,"nlist");
			command[46] = new char[sizeof("rhelp")+1]; 		strcpy(command[46] ,"rhelp");
			command[47] = new char[sizeof("trace")+1]; 		strcpy(command[47] ,"trace");
			command[48] = new char[sizeof("cdup")+1]; 		strcpy(command[48] ,"cdup");
			command[49] = new char[sizeof("image")+1]; 		strcpy(command[49] ,"image");
			command[50] = new char[sizeof("ntrans")+1]; 	strcpy(command[50] ,"ntrans");
			command[51] = new char[sizeof("rename")+1]; 	strcpy(command[51] ,"rename");
			command[52] = new char[sizeof("type")+1]; 		strcpy(command[52] ,"type");
			command[53] = new char[sizeof("chmod")+1]; 		strcpy(command[53] ,"chmod");
			command[54] = new char[sizeof("lcd")+1]; 		strcpy(command[54] ,"lcd");
			command[55] = new char[sizeof("open")+1]; 		strcpy(command[55] ,"open");
			command[56] = new char[sizeof("reset")+1]; 		strcpy(command[56] ,"reset");
			command[57] = new char[sizeof("user")+1]; 		strcpy(command[57] ,"user");
			command[58] = new char[sizeof("close")+1]; 		strcpy(command[58] ,"close");
			command[59] = new char[sizeof("ls")+1]; 		strcpy(command[59] ,"ls");
			command[60] = new char[sizeof("prompt")+1]; 	strcpy(command[60] ,"prompt");
			command[61] = new char[sizeof("restart")+1]; 	strcpy(command[61] ,"restart");
			command[62] = new char[sizeof("umask")+1]; 		strcpy(command[62] ,"umask");
			command[63] = new char[sizeof("cr")+1]; 		strcpy(command[63] ,"cr");
			command[64] = new char[sizeof("macdef")+1]; 	strcpy(command[64] ,"macdef");
			command[65] = new char[sizeof("passive")+1]; 	strcpy(command[65] ,"passive");
			command[66] = new char[sizeof("rmdir")+1]; 		strcpy(command[66] ,"rmdir");
			command[67] = new char[sizeof("verbose")+1]; 	strcpy(command[67] ,"verbose");
			command[68] = new char[sizeof("delete")+1]; 	strcpy(command[68] ,"delete");
			command[69] = new char[sizeof("mdelete")+1]; 	strcpy(command[69] ,"mdelete");
			command[70] = new char[sizeof("proxy")+1]; 		strcpy(command[70] ,"proxy");
			command[71] = new char[sizeof("runique")+1]; 	strcpy(command[71] ,"runique");       
			command[72] = new char[sizeof("e")+1]; 	strcpy(command[71] ,"e");       
//			command[73] = new char[sizeof("e")+1]; 	strcpy(command[71] ,"runique");       
		



			request[0]  = new char[strlen("SYST")+1];  	strcpy(request[0] ,"SYST");
			request[1]  = new char[strlen("QUIT")+1];	strcpy(request[1] ,"QUIT");
			request[2]  = new char[strlen("TYPE")+1];	strcpy(request[2] ,"TYPE");
			request[3]  = new char[strlen("PORT ")+1];	strcpy(request[3] ,"PORT ");
			request[4]  = new char[strlen("LIST")+1];	strcpy(request[4] ,"LIST");
			request[5]  = new char[strlen("CWD ")+1];	strcpy(request[5] ,"CWD ");
			request[6]  = new char[strlen("PWD")+1];	strcpy(request[6] ,"PWD");
			request[7]  = new char[strlen("RETR ")+1];	strcpy(request[7] ,"RETR ");
			request[8]  = new char[strlen("USER")+1];	strcpy(request[8] ,"USER ");
			request[9]  = new char[strlen("PASS")+1];	strcpy(request[9] ,"PASS ");
			request[10] = new char[strlen("REST ")+1];	strcpy(request[10],"REST ");
			request[11] = new char[strlen("SIZE")+1];	strcpy(request[11],"SIZE ");
			request[12] = new char[strlen("MDTM")+1];	strcpy(request[12],"MDTM");
			request[13] = new char[strlen("STOR ")+1];	strcpy(request[13],"STOR");
			request[14] = new char[strlen("CDUP")+1];	strcpy(request[14],"CDUP");
			request[15] = new char[strlen("NOOP")+1];	strcpy(request[15],"NOOP");
			request[16] = new char[strlen("GET ")+1];	strcpy(request[16],"GET ");
			request[17] = new char[strlen("NLST")+1];	strcpy(request[17],"NLST");
			request[18] = new char[strlen("PASV")+1];	strcpy(request[18],"PASV");
			request[19] = new char[strlen("ABOR")+1];	strcpy(request[19],"ABOR");
			request[20] = new char[strlen("MKD")+1];	strcpy(request[20],"MKD");
			request[21] = new char[strlen("RMD")+1];	strcpy(request[21],"RMD");
			request[22] = new char[strlen("DELE")+1];	strcpy(request[22],"DELE");
			request[23] = new char[strlen("RNFR")+1];	strcpy(request[23],"RNFR");
			request[24] = new char[strlen("RNTO")+1];	strcpy(request[24],"RNTO");
			request[25] = new char[strlen("APPE")+1];	strcpy(request[25],"APPE");
			request[26] = new char[strlen("STOU")+1];	strcpy(request[26],"STOU");
		}
		~FtpCommand()
		{
			
			for(int i=0;i<27;i++)
				delete [] request[i];

			for(int i=0;i<73;i++)
			{
				delete [] command[i];
			}
	}

};
#endif
