/**
		@file 	ftpserver.cpp	
		@data	2009/08/10
		@author	최영업(cyu0070@naver.com) Terapi
		@brief  Server코드의 메인에 해당하는 파일

*/
#include "ftpserver.h"

UserManager *uarr[5];
int RootStream::Server_Socket=0;
int  FtpServer::s_Server_Stop=0;

void strreverse(char* begin, char* end) 
{
	char aux;
	while(end>begin)
		aux=*end, *end--=*begin, *begin++=aux;
}
/**
 	@return	NULL
*/
void FtpServer::itoa(int value, char* str, int base) 
{
	static char num[] = "0123456789abcdefghijklmnopqrstuvwxyz";
	char* wstr=str;
	int sign;
	if (base<2 || base>35)
	{ 
		*wstr='\0'; 
		return; 
	}
	if ((sign=value) < 0) 
		value = -value;
	do 
		*wstr++ = num[value%base]; 
	while(value/=base);

	if(sign<0) 
		*wstr++='-';
	*wstr='\0';
	strreverse(str,wstr-1);
}
void Check_TimeOuts(UserManager** uarr,pthread_mutex_t mutex,char* msg_buf)
{
	int n;
	time_t t;
	Handler hand;
	t=time(NULL);

	for (n=0; n<Accepter::s_Cur_User_cnt; n++) 
	{
		if (uarr[n]->sock) 
		{
			switch (uarr[n]->state) 
			{
			case USR_ONLINE:
				if (uarr[n]->pid==0 || waitpid(uarr[n]->pid,NULL,WNOHANG)<0) 
				{
					uarr[n]->pid=0;
					if ( t - uarr[n]->idletime >= Conf::sIdleTimeOut ) 
						hand.handle_timeout(uarr,mutex,msg_buf,n);
				} 
				else
					uarr[n]->idletime=t;
				break;

			case USR_USER:

			case USR_PASS:
				if (t-uarr[n]->idletime>=Conf::sLoginTimeOut) 
					hand.handle_timeout(uarr,mutex,msg_buf,n);
				break;

			default: // better 
				hand.handle_suspects(uarr,mutex,msg_buf,n);
				break;
			}
		}
	}
}
void cleanchild(int nr) 
{
	while ( wait3(NULL, WNOHANG, NULL)>0 );
	signal(SIGCHLD,cleanchild);
}
void do_changeroot() 
{
	char s[MAXPATHLEN+4]={0,};
	for(int t=0;t<10 ;t++)
	{
		if((int)Conf::s_ServerRoot[t] == 10)
			break;
		else
			s[t] = Conf::s_ServerRoot[t];
	}
	
	if (Conf::sRealChangeRoot) 
	{
		if (getuid()!=0) 
		{
			Conf::sRealChangeRoot=0;

			if (!Conf::sDaemonMode) 
				printf("Chroot only works with root privileges.\n");
			return;
		}

		chdir(s);
		chroot(s);
	}
	
}

	int i,n,addr;
	unsigned int sock_size;
	struct timeval tv;
	struct sockaddr_in sa;
	char cmd[1024];






/**
 * @return  정상종료 0
 * 			Readini -11
 * 			Userdata -12
 * 			socket error -1
 *			bind   error -2
 * 			listen error -3
 */

///<서버에 대한 프로토콜 설정 
///<socket는 rootstream에서 class로 선언된	정보를가지고 옴

int FtpServer::Pre_Run(char *msg_buf)		
{
/*	
	int i,n,addr;
	unsigned int sock_size;
	struct timeval tv;
	struct sockaddr_in sa;
	char cmd[1024];
	int return_value=0;
*/
	ServerManager sm;
	Accepter ac;
	RootStream rs;
	User usr;	
	Conf cn;
	Listener li;
	LoginInfo login;
	
	///< Config file에서 서버에 대한 설정부분을	가지고옮
	if(cn.Readini())
	{
		cout << "Cannot find [ Configuration file ] make sure it's available."<<endl;
		return -11;
	}
	if(login.m_ReadUserInfo(msg_buf))
	{
		cout <<"Cannot find [ Userinfo file ] make sure it's available." << endl;
		return -12;
	}
	do_changeroot();

	signal(SIGPIPE,SIG_IGN);
	signal(SIGCHLD,cleanchild);

	Conf::sServerPort =21;

	
	if ((RootStream::Server_Socket=socket(PF_INET,SOCK_STREAM,0))==INVALID_SOCKET) 
	{
		i=(int)errno;
		if(Conf::sDaemonMode)
			cout<<"Error: could not create server socket"<<( i ) << endl;
		//exit(1);
		return -1;
	}

	i=1;
	if (setsockopt(RootStream::Server_Socket,SOL_SOCKET,SO_REUSEADDR,(void *)&i,sizeof(i))<0)
		cout << "setsockopt failed."<<endl;



	sock_size=sizeof(struct sockaddr_in);
	memset(&sa,0,sock_size);
	sa.sin_family=PF_INET;
	sa.sin_port=htons(Conf::sServerPort);
	addr=INADDR_ANY;
	memcpy(&sa.sin_addr.s_addr,&addr,sizeof(int));

	if (bind(RootStream::Server_Socket,(struct sockaddr *)&sa,sock_size)<0) 
	{
		cout << "Error: bind failed.";
		cout << "       port "<< Conf::sServerPort <<" already in use ?"<<endl;
		return -2;
	}

	if (listen(RootStream::Server_Socket,5)<0) 
	{
		cout << "Error: listen failed."<<endl;
		return -3;
	}
	
	return 0;
}

int FtpServer::Run( pthread_mutex_t mutex ,char* msg_buf ,bool Server_State)
{	
	cout <<"RUN "<<Server_State<<endl;
	ServerManager sm;
	Accepter ac;
	User usr;	
	Listener li;
	LoginInfo login;
	Handler hn;
	
	fd_set fds;
	FD_ZERO(&fds);
	FD_SET(1,&fds);
	FD_SET(RootStream::Server_Socket,&fds);
	
	if (!Server_State) 
	{
		cout <<" server_stop "<<endl;
		
		for(int i=0;i<ac.s_Cur_User_cnt;i++)
		{
			hn.kill_connection(uarr,msg_buf,i);
		}

		close(RootStream::Server_Socket);
		return -2;
	}


	for (int i=0;i<Accepter::s_Cur_User_cnt;i++)
	{
		if (uarr[i]->sock)
			FD_SET(uarr[i]->sock,&fds);
	}

	
	tv.tv_sec=REACTION_TIME;
	tv.tv_usec=0L;
	n=select(100,&fds,NULL,NULL,&tv);


	if (n<0) 
	{
		if (errno==EINTR)
			return -1;
		//				continue;
		i=(int)errno;
		fprintf(stderr,"*** Fehler: select (ret: %d,errno=%d).\n",n,i);
		exit(1);
	}
	if (FD_ISSET(1,&fds))
	{
		i=read(1,cmd,sizeof(cmd));
		if (i<1) 
			return -1;
		//				continue;
		cmd[i-1]=0;
		sm.Server_cmd(uarr,mutex,msg_buf,cmd);

		if (!Server_State) 
		{
			cout <<" server_step ";
			return -2;
		}
	}


	if (FD_ISSET(RootStream::Server_Socket,&fds))			///< 서버등록
	{
		uarr[Accepter::s_Cur_User_cnt] = new  UserManager( 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "0","0","0" );
		ac.usercheck(uarr,mutex,msg_buf,Accepter::s_Cur_User_cnt,fds, sa );
	}

	for (int i=0;i<Accepter::s_Cur_User_cnt;i++) 
	{
		if (uarr[i]->sock) 
		{
			
			if (FD_ISSET(uarr[i]->sock,&fds))
			{
				li.listen_loop(uarr,mutex,msg_buf,i);
			}
		}
	}
	Check_TimeOuts(uarr,mutex,msg_buf);
	//	}

	//	close(RootStream::Server_Socket);


}


