/**
  @file 	handler.cpp
  @date		2009/08/10
  @author	최영업(cyu0070@naver.com) Terapi
  @brief    Client 에서 들어온 명령어를 처리하는 함수	
 */

using namespace std;

#include "handler.h"

bool Handler::first_connect_userid=false;///<접속한 유져가 있었는지 없었는지 판단
bool Handler::first_connect_passwd=false;///<접속한 유져가 있었는지 없었는지 판단
bool Handler::anonymous_login=false;///<접속한 유져가 있었는지 없었는지 판단

unsigned char *getmyip(int sock) 
{
	static unsigned char myip[4];
	struct sockaddr_in sa;
	int size;

	size=sizeof(struct sockaddr_in);
	memset(myip,0,sizeof(myip));
	if (getsockname(sock, (struct sockaddr *)&sa, (socklen_t*)&size)==0) 
		memcpy(myip,&sa.sin_addr,sizeof(myip));

	return myip;
}
int newlist(UserManager **uarr,pthread_mutex_t mutex,char* msg_buf,int soc,int nr,int format,char *directory,char *mask, int callback(UserManager**, pthread_mutex_t, char*,int,int,char *)) 
{
//	cout << "new_list "<<endl;
	DIR *dir;
	struct dirent *entr;

	char filename[1024];
	char line[1024+80];
	char datestr[128];
	int dirlen,i;
	time_t timeval;
	struct stat st;
	struct tm *ntime;

	if (directory==NULL)
		return 0;

	strcpy(filename,directory);
	strcat(filename,"/");
	dirlen=strlen(filename);

	if ((dir=opendir(directory))==NULL) 
		return 0;

//	if(Conf::sDaemonMode)
//		fprintf(stderr,"list(): %s\n",directory);

	if (format==FORMAT_HTML) 
	{
		sprintf(line,"Content-type: text/html\r\n\r\n""<html><head><title>Directory contents: %s""</title></head><body>\r\n",directory);
		callback(uarr,mutex,msg_buf,soc,nr,line);
	}

	while ((entr=readdir(dir))!=NULL) 
	{
		if (entr->d_name[0]=='.') 
		{
			if (strcmp(entr->d_name,".")==0 ||  strcmp(entr->d_name,"..")==0) 
			{
				continue;
			}
		}
		if(Conf::sDaemonMode)
		{
//			fprintf(stderr,"--------->  list_match(%s,%s)\n",entr->d_name,mask);
//			fprintf(stderr,"--------->  directory  %s,\n",directory);
//			fprintf(stderr,"--------->  dir        %s,\n",dir);
		}

		if (list_match(entr->d_name,mask)) 
		{
			if (format==FORMAT_SHORT) 
			{
				strcpy(line,entr->d_name);
				strcat(line,"\r\n");
				if (!callback(uarr,mutex,msg_buf,soc,nr,line)) 
					break;
			}
			else 
			{
				// stat 
				if (strlen(entr->d_name)+dirlen>=1024) 
					continue;  // sorry ... 
				strcpy(filename+dirlen,entr->d_name);
				if (stat(filename,&st)<0) 
					continue;

				// date 

				timeval=time(NULL);
				ntime=localtime(&timeval);
				i=ntime->tm_year;

				ntime=localtime(&st.st_mtime);

				if (ntime->tm_year==i)
					strftime(datestr,sizeof(datestr),"%b %d %H:%M",ntime);
				else 
					strftime(datestr,sizeof(datestr),"%b %d  %Y",ntime);

				// permissions 

				if (!S_ISDIR(st.st_mode) && !S_ISLNK(st.st_mode) && !S_ISREG(st.st_mode)) 
					continue;

				if (format==FORMAT_LONG) 					//list
				{
					sprintf(line,"%c%c%c%c%c%c%c%c%c%c %3d %s %s %13ld %s %s\r\n",
							S_ISDIR(st.st_mode) ? 'd' : S_ISLNK(st.st_mode) ? 'l' : '-',
							st.st_mode & S_IRUSR ? 'r' : '-',
							st.st_mode & S_IWUSR ? 'w' : '-',
							st.st_mode & S_IXUSR ? 'x' : '-',
							st.st_mode & S_IRGRP ? 'r' : '-',
							st.st_mode & S_IWGRP ? 'w' : '-',
							st.st_mode & S_IXGRP ? 'x' : '-',
							st.st_mode & S_IROTH ? 'r' : '-',
							st.st_mode & S_IWOTH ? 'w' : '-',
							st.st_mode & S_IXOTH ? 'x' : '-',
							(int)st.st_nlink,
							LoginInfo::s_username,
							"ftp",
							(long)st.st_size,
							datestr,
							entr->d_name);

					if (!callback(uarr,mutex,msg_buf,soc,nr,line)) 
						break;
				}
				else if(format == FORMAT_SHORT)					//NameList
				{
					sprintf(line,"%s\r\n",
							entr->d_name);

					if (!callback(uarr,mutex,msg_buf,soc,nr,line)) 
						break;
				}
				else 
				{
					// HTML-format 
					sprintf(line,"<a href=\"%s%s\">%s%s</a> %ld %s<br>\r\n",directory,entr->d_name,	(S_ISDIR(st.st_mode) ? "/" : ""),entr->d_name,(long)st.st_size,datestr);
					if (!callback(uarr,mutex,msg_buf,soc,nr,line)) 
						break;
				}
			}
		}
	}
	closedir(dir);

	if (format==FORMAT_HTML) 
	{
		sprintf(line,"</body></html>\r\n");
		callback(uarr,mutex,msg_buf,soc,nr,line);
	}
	return 1;

}
int guess_star(char *str,char *mask) 
{
	// pump from here !!! 

	if (mask[0]==0)
		return 1;

	for (int i=0;i<strlen(str);i++)
		if (list_match(str+i,mask)) 
			return 1;
	
	return 0;
}
int list_match(char *str,char *mask) 
{
	int i=0;
	// character per character matching 
	do {
		if (mask[i]=='*')
			return	guess_star(str,mask+1);
		
		
		if (mask[i]=='?') 
		{
			if (str[i]!=0) 
				continue;

			else
				return 0;

		}

		if (mask[i]!=str[i]) 
			return 0;

	} while (mask[++i]!=0);


	if (str[i]==0)
		return 1;
	else
		return 0;
}




void Handler::user_return_addmsg(UserManager **uarr,pthread_mutex_t mutex,char* msg_buf, char* add_buf,int nr,int id)
{
	UserCommand uc;
	char t_buf[1024];
	
	strcpy(t_buf, add_buf);
	strcat(t_buf, uc.ftp_returnstr[id]);

	pthread_mutex_lock(&mutex);
	write(uarr[nr]->sock,uc.ftp_returnstr[id],strlen(uc.ftp_returnstr[id]));
	strcpy(msg_buf,	t_buf );
	pthread_mutex_unlock(&mutex);

	memset(add_buf,0,1024);

//	sleep(1);
}
void Handler::user_return_only(UserManager **uarr,int nr,int id)
{
	UserCommand uc;
	write(uarr[nr]->sock,uc.ftp_returnstr[id],strlen(uc.ftp_returnstr[id]));
}
void Handler::user_return(UserManager **uarr,pthread_mutex_t mutex,char* msg_buf,int nr,int id)
{
	UserCommand uc;

	pthread_mutex_lock(&mutex);
	write(uarr[nr]->sock,uc.ftp_returnstr[id],strlen(uc.ftp_returnstr[id]));
	strcpy(msg_buf,	uc.ftp_returnstr[id] );
	pthread_mutex_unlock(&mutex);
}
/**
  @return	0 이면 성공  -1이면
 */
int Handler::user_spool(UserManager **uarr,char* msg_buf,int nr,int id,char *file)
{
	Handler hand;

	char buffer[1024],marker[32];
	FILE *fp;
	fd_set fds;
	struct timeval tv;
	int n;

	if (file[0]!=0) 
	{
		if ((fp=fopen(file,"r"))!=NULL) 
		{
			n=0;
			while (fgets(buffer,sizeof(buffer)-1,fp)!=NULL) 
			{
				if (n==0) 
					sprintf(marker,"%d- ",id);
				write(uarr[nr]->sock,marker,strlen(marker));

				if ((n=strlen(buffer))>0) 
				{
					if (buffer[n-1]=='\n') 
						buffer[n-1]=0;
					strcat(buffer,"\r\n");
				}
				do {
					FD_ZERO(&fds);
					FD_SET(uarr[nr]->sock,&fds);
					tv.tv_sec=Conf::sTransferTimeOut;
					tv.tv_usec=0;

					if (select(uarr[nr]->sock+1,NULL,&fds,NULL,&tv)<=0) 
					{
						fprintf(stderr,"Spool (%d) timeout to client %d.\n",id,nr+1);
						hand.kill_connection(uarr,msg_buf,nr);
						return -1;	
					}
				} while (!FD_ISSET(uarr[nr]->sock,&fds));
				write(uarr[nr]->sock,buffer,strlen(buffer));
			}
		}
	}

	return 0;
}

int Handler::checkpath(UserManager **uarr,char* msg_buf,int nr,char *param,char *path)

{
	for(int i=0; i<strlen(param);i++)
	{
		if((int)param[i] ==13 || (int)param[i] ==10 )
		{
			param[i] = 0;
		}
	}


	char cmd[MAXPATHLEN+4];
	char allowed[MAXPATHLEN+4];
	if (!strcmp(uarr[nr]->rootdir,"/")) 
		strcpy(allowed,uarr[nr]->rootdir);
	else 
	{
		// should not happen 
		if (strlen(uarr[nr]->rootdir)>=MAXPATHLEN)
			return 1;

		sprintf(allowed,"%s/",uarr[nr]->rootdir);
	}

	if (strlen(allowed)+strlen(uarr[nr]->reldir)>=sizeof(cmd)) 
		return 1;
	sprintf(cmd,"%s%s",allowed,uarr[nr]->reldir);



	if (param) 
	{
		if (param[0]!='/') 
		{
			if (strlen(cmd)+strlen(param)>=sizeof(cmd)) 
				return 1;
			strcat(cmd,param);
		}
		else
		{
			if (strlen(allowed)+strlen(&param[1])>=sizeof(cmd)) 
				return 1;
			strcpy(cmd,allowed); //cmd 문자열 카피
			strcat(cmd,&param[1]); ///< cmd 뒤에 문자열 붙이기

		}
	}

	if (!realpath(cmd,path)) ;
	//	return 1;

	if (strlen(path)>=MAXPATHLEN)
		return 1;


	strcat(path,"/");
	strcpy(cmd,path);
	cmd[strlen(allowed)]=0;

	if (strcmp(cmd,allowed))
		return 1;

	return 0;

}
void Handler::kill_connection(UserManager **uarr,char* msg_buf,int nr)
{   
	ServerManager sm;
	Accepter ac;	

	char buffer[256];
	time_t tm;
	char t_buf[1024];
	char tt_buf[1024];

	ac.s_Cur_User_cnt--;

	if(Conf::sDaemonMode) 
	{
		cout<<"User"<< nr+1 <<", killed."<<endl;
		strcpy(t_buf,"User ");
		sprintf(tt_buf,"%d ",nr+1);
		strcat(t_buf,tt_buf);
		strcat(t_buf,", killed.\n");
		strcpy(msg_buf,t_buf);
		sleep(1);
		


//		sm.out_prompt();
	}
	// close passive port 
	if (uarr[nr]->pasvsock) 
	{
		close(uarr[nr]->pasvsock);
		uarr[nr]->pasvsock=0;
	}

	// checking retr subprocess 
	if (uarr[nr]->pid) 
		kill(uarr[nr]->pid,SIGTERM);
	uarr[nr]->pid=0;

	// close connection and tidy up 
	close(uarr[nr]->sock);

	uarr[nr]->sock=0;
	uarr[nr]->dataport=0;

	/*	if (logfile!=NULL) 
		{
		tm=time(NULL);
		strcpy(buffer,ctime(&tm));
		buffer[strlen(buffer)-1]=0;

		fprintf(logfile,"%s: LOGOUT: user %d ",buffer,nr+1);
		if (uarr[nr]->usertype<logininfocount)
		fprintf(logfile,"%s ",uarr[nr]->username);
		else 
		fprintf(logfile,"nologin ");
		fprintf(logfile,"%s (%d.%d.%d.%d)\n",
		uarr[nr]->url,
		uarr[nr]->userip[0],uarr[nr]->userip[1],
		uarr[nr]->userip[2],uarr[nr]->userip[3]);
		fflush(logfile);
		}*/

	
	
//	write(nr+4,"331\r\n",5);


}
void childtimeout(int nr)
{  
	//	exit(0);
};
int  Handler::waitaccept(UserManager **uarr,int nr)
{
	int socksize,soc;
	struct sockaddr_in sai;

	signal(SIGALRM,childtimeout);
	alarm(Conf::sTransferTimeOut);                 //60  60초
	socksize=sizeof(sai);
	soc=accept(uarr[nr]->pasvsock,(struct sockaddr *)&sai,(socklen_t*)&socksize);
	signal(SIGALRM,SIG_IGN);
	return soc;
}
int  list_callback(UserManager **uarr,pthread_mutex_t mutex,char* msg_buf, int soc,int nr,char *line) 
{ 
	fd_set fds;
	Handler hand;
	struct timeval tv;

	do {
		FD_ZERO(&fds);
		FD_SET(soc,&fds);
		tv.tv_sec=Conf::sTransferTimeOut;
		tv.tv_usec=0;

		if (select(soc+1,NULL,&fds,NULL,&tv)<=0) 
		{
			close(soc);
			hand.user_return(uarr,mutex,msg_buf,nr,RET_501);
			return 0;
		}
	} while (!FD_ISSET(soc,&fds));

	write(soc,line,strlen(line));

	return 1;
}
void Handler::do_list(UserManager **uarr, pthread_mutex_t mutex, char* msg_buf,int nr,char *param,int listtype) 
{ 
	Handler hand;
	UserCommand uc;

	struct hostent *hp;
	
	char cmd[1024],path[1024],mask[1024];
	char add_buf[1024];
	unsigned long addr;
	int soc,n;
	unsigned int socksize;
	struct sockaddr_in sai;
	char nullch[8];
	char *cmask;

	strcpy(nullch,".");
	if (uarr[nr]->pasvsock<=0 && uarr[nr]->dataport==0) 
	{
		user_return(uarr,mutex,msg_buf,nr,RET_501);
		exit(0);
	}
	mask[0]=0;
	if (param) 
	{
		while (param[0]=='-') 
		{
			n=1;
			while (param[n]!=' ' && param[n]!=0) 
				n++;
			if (param[n]==' ') 
				param=&param[n+1];
			else
				param=&param[n];
		}
		strcpy(cmd,param);

		if (strrchr(cmd,'*') || strrchr(cmd,'?')) 
		{
			if (strrchr(cmd,'/')) 
			{
				strcpy(mask,strrchr(cmd,'/')+1);
				*strrchr(cmd,'/')=0;
			}
			else 
			{
				strcpy(mask,cmd);
				cmd[0]=0;
			}
		}
		if (strrchr(cmd,'*') || strrchr(cmd,'?')) 
		{
			user_return(uarr,mutex,msg_buf,nr,RET_501);
			exit(0);
		}
	}
	else 
	{
		cmd[0]=0;
		param=nullch;
	}
	if (param[0]=='/') 
		param++;
	if (param[0]=='/') 
	{
		user_return(uarr,mutex,msg_buf,nr,RET_501);
		exit(0);
	}

	cmask=strrchr(mask,'/');

	if (cmask!=NULL) 
	{
		*cmask=0;
		cmask++;

		if (strlen(cmd)+strlen(mask)+2>sizeof(cmd)) 
		{
			user_return(uarr,mutex,msg_buf,nr,RET_501);
			exit(0);
		}
		strcat(cmd,"/");
		strcat(cmd,mask);
		strcpy(mask,cmask);
	}


	if (hand.checkpath(uarr,msg_buf,nr,cmd,path) || !strncmp(mask,"..",2)) 
	{
		user_return(uarr,mutex,msg_buf,nr,RET_501);
		exit(0);
	}


	if (uarr[nr]->pasvsock<=0) 
	{
		// IP-CHECK needed !!! 
		sprintf(cmd,"%d.%d.%d.%d", uarr[nr]->dataip[0],uarr[nr]->dataip[1], uarr[nr]->dataip[2],uarr[nr]->dataip[3]);
		addr=(unsigned long)inet_addr(cmd);
		if ((int)addr==-1) 
		{
			user_return(uarr,mutex,msg_buf,nr,RET_501);
			exit(0);
		}

		hp=gethostbyaddr((char *)&addr,sizeof(addr),AF_INET);


		if ((soc=socket(AF_INET,SOCK_STREAM,0))<0) 
		{
			user_return(uarr,mutex,msg_buf,nr,RET_501);
			exit(0);
		}
		socksize=sizeof(struct sockaddr_in);
		memset(&sai,0,socksize);
		sai.sin_family=AF_INET;
		sai.sin_port=htons(uarr[nr]->dataport);
		memcpy(&sai.sin_addr,&addr,sizeof(addr));

		
		if (connect(soc,(struct sockaddr *)&sai,socksize)<0) 
		{
//			user_return(uarr,mutex,msg_buf,nr,RET_501);
//			exit(0);
		};

	}
	else 
	{
		if ((soc=hand.waitaccept(uarr,nr))<=0)
		{
			user_return(uarr,mutex,msg_buf,nr,RET_501);
			exit(0);
		}
	}
	hand.user_return_only(uarr,nr,RET_150);
	strcat(add_buf,uc.ftp_returnstr[RET_150]);
	if (strlen(mask)==0)
		strcpy(mask,"*");

	if	(newlist(uarr,mutex,msg_buf,soc,nr,listtype,path,mask,list_callback))
	{
		user_return_addmsg(uarr,mutex,msg_buf,add_buf,nr,RET_226);
	}
	else
	{
		user_return_addmsg(uarr,mutex,msg_buf,add_buf,nr,RET_501);
	}

	close(soc);
	exit(0);
}
int  Handler::do_chdir(UserManager **uarr,char* msg_buf,int nr,char *param)
{
	char allowed[MAXPATHLEN+4],path[MAXPATHLEN+4];
	struct stat buf;
	
	if (checkpath(uarr,msg_buf,nr,param,path)) 
		return 1;

	if (strlen(uarr[nr]->rootdir)>=MAXPATHLEN) 
		return 1;
	
	sprintf(allowed,"%s/",uarr[nr]->rootdir);

//	cout <<"stat(path,&buf) ==> "<<stat(path,&buf)<<endl;

	if (!stat(path,&buf)) 
	{
		if (buf.st_mode & S_IFDIR) 
		{
			char *np;

			np=path+strlen(allowed)-1;
			if (strlen(np)>MAXPATHLEN)
				return 1;
			strcpy(uarr[nr]->reldir,np);
		}
		else 
			return 1;
	} 
	else
		return 1;

	return 0;

}
int  Handler::do_retr(UserManager **uarr, char* msg_buf,int nr,char *param) ///<파일카피
{
	struct hostent *hp;
	FILE *fp;
	char cmd[2048],path[2048];
	unsigned long addr;
	int soc;
	unsigned int socksize,n;
	struct sockaddr_in sai;
	unsigned long bytestot,bytesnow,byteslast;
	time_t tm_start,tm;
	fd_set fds;
	struct timeval tv;
	struct stat statb;
	Handler hand;
	ServerManager sm;

	if (uarr[nr]->pasvsock<=0 && uarr[nr]->dataport==0) 
		return RET_501;
	if (hand.checkpath(uarr,msg_buf,nr,param,path)) 
		return RET_501;

	if (path[strlen(path)-1]=='/')
		path[strlen(path)-1]=0;

	if (stat(path,&statb)) 
		return RET_501;


	if (S_ISDIR(statb.st_mode)) 
		return RET_550;

	else 
	{
		if ((uarr[nr]->perm & PERM_DOWNLOAD)==0) 
			return RET_553;
	}

	if (uarr[nr]->pasvsock<=0) 
	{
		// IP-CHECK needed !!! 
		sprintf(cmd,"%d.%d.%d.%d",	uarr[nr]->dataip[0],uarr[nr]->dataip[1],
				uarr[nr]->dataip[2],uarr[nr]->dataip[3]);
		addr=(unsigned long)inet_addr(cmd);
		if ((int)addr==-1) 
			return RET_501;

		hp=gethostbyaddr((char *)&addr,sizeof(addr),AF_INET);

		if ((soc=socket(AF_INET,SOCK_STREAM,0))<0)
			return RET_501;
		socksize=sizeof(struct sockaddr_in);
		memset(&sai,0,socksize);
		sai.sin_family=AF_INET;
		sai.sin_port=htons(uarr[nr]->dataport);
		memcpy(&sai.sin_addr,&addr,sizeof(addr));
		if (connect(soc,(struct sockaddr *)&sai,socksize)<0)
			return RET_501;
	}
	else 
	{
		socksize=sizeof(sai);
		if ((soc=accept(uarr[nr]->pasvsock,(struct sockaddr *)&sai,&socksize))<0) 
			return RET_501;
	}
	if ((fp=fopen(path,"r"))==NULL) 
	{
		close(soc);
		return RET_501;
	}
	fseek(fp,0,SEEK_END);

	bytestot=ftell(fp);
	bytesnow=byteslast=uarr[nr]->resume;

	sprintf(cmd,  "150 Opening BINARY mode data connection for '%s' (%ld bytes).\r\n",	param,bytestot);
	fseek(fp,uarr[nr]->resume,SEEK_SET);

	write(uarr[nr]->sock,cmd,strlen(cmd));

	//	if (!daemonmode) 
	//	{
	printf("User %d, downloading: %s\n",nr+1,path);
	sm.out_prompt();
	//	}

	tm_start=time(NULL)-1;


	while ((n=fread(cmd,1,sizeof(cmd),fp))>0) 
	{
		do {
			FD_ZERO(&fds);
			FD_SET(soc,&fds);
			tv.tv_sec=60;
			tv.tv_usec=0;
			//write

			if (select(soc+1,NULL,&fds,NULL,&tv)<=0) 
			{
				//fprintf(stderr,"Send timeout to client %d.\n",nr+1);
				fclose(fp);
				close(soc);
				return RET_501;
			}
		} while (!FD_ISSET(soc,&fds));

		write(soc,cmd,n);

		bytesnow+=n;

		if (bytesnow-byteslast > TRFMSG_INTERVAL) 
		{
			byteslast+=TRFMSG_INTERVAL;
			tm=time(NULL);

			//			if (!daemonmode) 
			//			{
			printf("User %d, %ld / %ld kB (%ld%%) at %ldkB/s\n",nr+1,bytesnow/1024,bytestot/1024,(((bytesnow>>7)*100)/(bytestot>>7)),(bytesnow/(tm-tm_start))/1024);
			sm.out_prompt();
			//			}
		}
	}

	fclose(fp);
	close(soc);
	return RET_226;

}
int  Handler::do_stor(UserManager **uarr,pthread_mutex_t mutex, char* msg_buf,int nr,char *param) 
{
	struct hostent *hp;
	FILE *fp;
	char cmd[2048],path[2048],path2[2048];
	unsigned long addr;
	int soc,ret;
	unsigned int socksize,n;
	long byteslast,bytesnow;
	struct sockaddr_in sai;
	time_t tm_start,tm;
	fd_set fds;
	struct timeval tv;

	ServerManager sm;
	Handler hand;

	if (uarr[nr]->pasvsock<=0 && uarr[nr]->dataport==0) 
		return 1;
	if (param==NULL)
		return 1;

	if (strrchr(param,'/'))
		param=strrchr(param,'/')+1;
	if (strlen(param)==0) 
		return 1;

	strcpy(cmd,".");
	if (hand.checkpath(uarr,msg_buf,nr,cmd,path)) 
		return 1;

	if (strlen(path)+strlen(param)+1>sizeof(path))
		return 1;
	strcat(path,param);

	// BUGFIX 


	if ((ret=readlink(path,path2,sizeof(path2)-1))>=0) 
	{
		path2[ret]=0;


		strcpy(path,path2);
		if (strrchr(path2,'/')) 
		{
			*(param=strrchr(path2,'/'))=0;
			param++;

			if (checkpath(uarr,msg_buf,nr,path2,path)) 
				return 1;
			if (path[strlen(path)-1]!='/') 
			{
				if (strlen(path)+strlen(param)+2>sizeof(path)) 
					return 1;
				strcat(path,"/");
				strcat(path,param);
			}

#ifdef DEBUG
			printf("resolved: %s\n",path);
#endif
		}
	}

	//	 END OF BUGFIX 

	// overwrite protection 
	if (!(uarr[nr]->perm & PERM_OVERWRITE)) 
	{
		fp=fopen(path,"r");
		if (fp!=NULL) 
		{
			fclose(fp);
			return 2;
		} 
	}

	if (uarr[nr]->pasvsock<=0)
	{
		// IP-CHECK needed !!! 
		sprintf(cmd,"%d.%d.%d.%d",
				uarr[nr]->dataip[0],uarr[nr]->dataip[1],
				uarr[nr]->dataip[2],uarr[nr]->dataip[3]);
		addr=(unsigned long)inet_addr(cmd);

		if ((int)addr==-1) 
			return 1;

		hp=gethostbyaddr((char *)&addr,sizeof(addr),AF_INET);

#ifdef DEBUG
		fprintf(stderr,"Making connection to: %s:%d\n",cmd,uarr[nr]->dataport);
#endif

		if ((soc=socket(AF_INET,SOCK_STREAM,0))<0) 
			return 1;
		socksize=sizeof(struct sockaddr_in);
		memset(&sai,0,socksize);
		sai.sin_family=AF_INET;
		sai.sin_port=htons(uarr[nr]->dataport);
		memcpy(&sai.sin_addr,&addr,sizeof(addr));

		if (connect(soc,(struct sockaddr *)&sai,socksize)<0) 
			return 1;
	}
	else 
	{
		socksize=sizeof(sai);
		if ((soc=accept(uarr[nr]->pasvsock,(struct sockaddr *)&sai,&socksize))<0) 
		{
			hand.user_return(uarr,mutex,msg_buf,nr,RET_501);
			return 1;
		}
	}

	if ((fp=fopen(path,"w"))==NULL) 
	{
		close(soc);
		return 1;
	}

	bytesnow=byteslast=0;
	sprintf(cmd,"150 FILE: %s\r\n",param);
	write(uarr[nr]->sock,cmd,strlen(cmd));

	//	if (!daemonmode) 
	//	{
	printf("User %d, uploading: %s\n",nr+1,param);
	sm.out_prompt();
	//	}

	tm_start=time(NULL)-1;
	while (1) 
	{
		FD_ZERO(&fds);
		FD_SET(soc,&fds);
		tv.tv_sec=Conf::sTransferTimeOut;
		tv.tv_usec=0;
		//read
		if (select(soc+1,&fds,NULL,NULL,&tv)<=0) 
		{
			fclose(fp);
			close(soc);
#ifdef DEBUG
			fprintf(stderr,"Receive timeout from client %d.\n",nr+1);
#endif
			return 3;
		}

		if (FD_ISSET(soc,&fds)) 
		{
			n=read(soc,cmd,sizeof(cmd));
			if (n<=0) 
				break; // client closed con, file complete ? should be ! 

			fwrite(cmd,1,n,fp);
			bytesnow+=n;
			if (bytesnow-byteslast > TRFMSG_INTERVAL) 
			{
				byteslast+=TRFMSG_INTERVAL;
				tm=time(NULL);
				//if (!daemonmode) 
				//{
				printf("User %d, %ldkB at %ldkB/s\n",nr+1,bytesnow/1024,(bytesnow/(tm-tm_start))/1024);
				sm.out_prompt();
				//}
			}
		}
	}

	fclose(fp);

	close(soc);

#ifdef DEBUG
	fprintf(stderr,"Client %d finished uploading.\n",nr+1);
#endif

	return 0;
}
/**
  @return	
  @warning	잘못되었을시에 예외처리 현재 없음
  anonymous 처리안됨
 */

int  Handler::do_user(UserManager **uarr, pthread_mutex_t mutex,char* msg_buf,int nr,char *param)
{
	Handler hand;
	LoginInfo login;
	UserCommand uc;
	

	if (strlen(param)<1) 
	{
		hand.handle_suspects(uarr,mutex,msg_buf,nr);
		return -1;
	}
		
	if (!strcmp(param,"a\r"))
	{
		uarr[nr]->usertype =1;
		if(nr ==0 && first_connect_userid == false) ///< 1명 이상의 유저가 들어오게 되면 원래 USER정보와 입력 USER정보를 비교하게된다.	밑과정은 한번만 실행되게 처리
		{
			strcat(login.s_username,"\r");
			first_connect_userid = true;
		}
		pthread_mutex_lock(&mutex);
		strcpy(msg_buf,uc.ftp_returnstr[9]);
		sleep(1);
		pthread_mutex_unlock(&mutex);
		write(uarr[nr]->sock,uc.ftp_returnstr[9],strlen(uc.ftp_returnstr[9]));

		uarr[nr]->state=USR_PASS;
		uarr[nr]->idletime=time(NULL);
		
		anonymous_login = true;
		return 0;
	}
	else
		anonymous_login = false;

	if(nr ==0 && first_connect_userid == false) ///< 1명 이상의 유저가 들어오게 되면 원래 USER정보와 입력 USER정보를 비교하게된다.	밑과정은 한번만 실행되게 처리
	{
		strcat(login.s_username,"\r");
		first_connect_userid = true;
	}

	
	///<ID 를 비교하는 함수.
	if (strcmp(param,login.s_username) == 0)	
	{
		if(Conf::sDaemonMode)
		{
			char t_buf[1024];
			memset(t_buf,0,1024);
			memset(msg_buf,0,1024);
			
			pthread_mutex_lock(&mutex);		
			strcat(t_buf,"USER ");
			strcat(t_buf,param);
			strcat(t_buf,"\n");

			strcpy(msg_buf,t_buf);
			sleep(1);
			pthread_mutex_unlock(&mutex);		
		}	
	}
	else
	{
		if(Conf::sDaemonMode)
		{
			memset(msg_buf,0,1204);
			strcpy(msg_buf," 514 user login failed\n");
		}
		return -1;
	}

	uarr[nr]->usertype =1;



	//	uarr[nr]->usertype=user;
	/*????
	  if (user<logininfocount) 
	  {
	  if (logininfo[uarr[nr]->usertype]->maxlogins>0) 
	  {
	  count=0;
	  for (n=0;n<maxusers;n++)
	  if (uarr[n]->sock!=0 && uarr[nr]->usertype==uarr[n]->usertype)
	  count++;

	  if (count>logininfo[uarr[nr]->usertype]->maxlogins) 
	  {
	  if (!daemonmode) 
	  {
	  cout<<"Info: Too many users of type '%s'.\n", logininfo[uarr[nr]->usertype]->username);
	  out_prompt();
	  }
	  user_return(uarr,msg_buf,nr,RET_530);
	  kill_connection(nr);
	  return;
	  }
	  } 
	  }
	  ????*/

	if (!strcmp(param,"anonymous")) 
		cout <<" anonymous "<<endl;
	//	{
	//		hand.user_return(uarr,msg_buf,nr,RET_331);
	/* 
	   {
	   hand.user_return(uarr,msg_buf,nr,RET_531);
	   hand.kill_connection(nr);
	   }*/
	//	}
	else 
	{
		pthread_mutex_lock(&mutex);
		
		memset(msg_buf,0,1204);
		strcpy(msg_buf,uc.ftp_returnstr[9]);
		sleep(1);
		pthread_mutex_unlock(&mutex);
		write(uarr[nr]->sock,uc.ftp_returnstr[9],strlen(uc.ftp_returnstr[9]));
	}


	uarr[nr]->state=USR_PASS;
	uarr[nr]->idletime=time(NULL);
	return 0;
}
void Handler::do_pass(UserManager **uarr, pthread_mutex_t mutex,char* msg_buf,int nr,char *param)
{

	char buffer[64];
	time_t tm;

	Handler hand;
	LoginInfo login;

	///< 1명 이상의 유저가 들어오게 되면 원래 USER정보와 입력 USER정보를 비교하게된다.	밑과정은 한번만 실행되게 처리
	if(nr == 0 && first_connect_passwd == false) 
	{
		strcat(login.s_passwd,"\r");
		first_connect_passwd = true;
	}
	if(anonymous_login == true)
	{
		uarr[nr]->perm =(int)PERM_NONE ;
		strcpy(buffer,"/home/");
	
	}

	else
	{


		if((strlen(param)<1)||(strcmp(param,login.s_passwd)))
	{
		hand.user_return(uarr,mutex,msg_buf,nr,RET_532);
		hand.kill_connection(uarr,msg_buf,nr);
		return;
	}

	uarr[nr]->perm=(int)LoginInfo::s_perm;
	strcpy(buffer,LoginInfo::s_root);
	}
	if (!realpath(buffer,uarr[nr]->rootdir)) 
	{
		hand.user_return(uarr,mutex,msg_buf,nr,RET_534);
		hand.kill_connection(uarr,msg_buf,nr);
		return;
	}
	uarr[nr]->state=USR_ONLINE;
	uarr[nr]->idletime=tm=time(NULL);

	sprintf(buffer,"230 User %s logged in.\r\n","a");
	
	pthread_mutex_lock(&mutex);
	char t_buf[1024];
	char tt_buf[1024]="NULL";
	memset(tt_buf,0,1024);

	//	패스워드는 패스워드값을 보여주는것이아니라 *를 통해서 보여줘야하기때문에 param의 길이를 읽어서 그만큼만 찍어준다.

	int length_str_param = strlen(param);
	for(int i=0;i<length_str_param-1;i++)
	{
		tt_buf[i]='*';
	}

	strcpy(t_buf,"PASS ");
	strcat(t_buf,tt_buf);
	strcat(t_buf,"\n");
	strcat(t_buf,"230 User name logged in.\n");
	strcpy(msg_buf,t_buf);
	sleep(1);	
	pthread_mutex_unlock(&mutex);
	
	write(uarr[nr]->sock,buffer,strlen(buffer));

}
void Handler::do_size(UserManager **uarr, pthread_mutex_t mutex, char* msg_buf,int nr,char *param)
{

	char path[2048];
	struct stat s;

	if (!checkpath(uarr,msg_buf,nr,param,path)) 
	{
		if (path[strlen(path)-1]=='/')
			path[strlen(path)-1]=0;

		if (stat(path,&s)==0)
		{
			sprintf(path,"213 %ld\r\n",(long int)s.st_size);
			write(uarr[nr]->sock,path,strlen(path));
			return;
		} 
	}

	user_return(uarr,mutex,msg_buf,nr,RET_501);
}
void Handler::do_mdtm(UserManager **uarr, pthread_mutex_t mutex,char* msg_buf,int nr,char *param)
{
	char path[1024],tm[32];
	struct stat s;

	if (!checkpath(uarr,msg_buf,nr,param,path)) 
	{
		if (path[strlen(path)-1]=='/')
			path[strlen(path)-1]=0;

		if (stat(path,&s)==0) 
		{
			strftime(tm,sizeof(tm),"%Y%m%d%H%M%S",gmtime(&s.st_mtime));
			sprintf(path,"213 %s\r\n",tm);
			write(uarr[nr]->sock,path,strlen(path));
			return;
		} 
	}

	user_return(uarr,mutex,msg_buf,nr,RET_501);
}
void Handler::do_pasv(UserManager **uarr,pthread_mutex_t mutex,char* msg_buf, int nr)
{   
	int addr;
	unsigned int size;
	struct sockaddr_in sa;
	char sbuffer[256];
	unsigned int port;
	unsigned char *myip;

	if (uarr[nr]->pasvsock>0) 
	{
		close(uarr[nr]->pasvsock);
		uarr[nr]->pasvsock=0;
	}

	if ((uarr[nr]->pasvsock=socket(AF_INET,SOCK_STREAM,0))<0) 
	{
		uarr[nr]->pasvsock=0;
		user_return(uarr,mutex,msg_buf,nr,RET_425);
		return;
	}

	port=1025;
	while (port<65536) 
	{
		size=sizeof(struct sockaddr_in);
		memset(&sa,0,size);

		sa.sin_family=AF_INET;
		sa.sin_port=htons(port);
		addr=INADDR_ANY;
		memcpy(&sa.sin_addr.s_addr,&addr,sizeof(int));

		if (bind(uarr[nr]->pasvsock,(struct sockaddr *)&sa,size)==0) 
		{
			cout<<"Error bind "<<endl;
			break;
		}

		port++;
	}
	if (port>=65536) 
	{
		close(uarr[nr]->pasvsock);
		uarr[nr]->pasvsock=0;
		user_return(uarr,mutex,msg_buf,nr,RET_425);
		return;
	}


	if (listen(uarr[nr]->pasvsock, 1) < 0) 
	{
		close(uarr[nr]->pasvsock);
		uarr[nr]->pasvsock=0;
		user_return(uarr,mutex,msg_buf,nr,RET_425);
		return;
	}

	myip=getmyip(uarr[nr]->sock);
	sprintf(sbuffer,"227 Entering Passive Mode (%d,%d,%d,%d,%d,%d)\r\n",myip[0],myip[1],myip[2],myip[3],(port>>8)&0xFF,port&0xFF);

	write(uarr[nr]->sock,sbuffer,strlen(sbuffer));

}
int  Handler::do_mkdir(UserManager **uarr,char* msg_buf,int nr,char *param)
{	
	Handler hand;
	char path[MAXPATHLEN+4];

	if (strlen(param)>512) 
		param[512]=0;
	if (hand.checkpath(uarr,msg_buf,nr,param,path)) 
		return 1;

	//	if (strlen(path)+strlen(param)>MAXPATHLEN) return 1;
	//	strcat(path,param);

#ifdef DEBUG
	cout<<"Making directory "<<path<<endl;
#endif

	return mkdir(path,0755);
}
int  Handler::do_rmdir(UserManager **uarr,char* msg_buf,int nr,char *param)
{
	char path[1024];
	char allowed[MAXPATHLEN+4];

	if (strlen(param)>512) 
		param[512]=0;
	if (checkpath(uarr,msg_buf,nr,param,path)) 
		return 1;
	if (!strcmp(uarr[nr]->rootdir,"/"))
		strcpy(allowed,uarr[nr]->rootdir);
	else 
	{
		// should not happen 
		if (strlen(uarr[nr]->rootdir)>=MAXPATHLEN)
			return 1;
		sprintf(allowed,"%s/",uarr[nr]->rootdir);
	}

	if (strcmp(allowed, path)==0) 
		return 1;
#ifdef DEBUG
	cout <<"Removing directory "<<path<<endl;
#endif
	cout <<"rmdir(path) "<<rmdir(path)<< endl;

	return rmdir(path);
}
int  Handler::do_dele(UserManager **uarr,char* msg_buf,int nr,char *param)
{
	Handler hand;
	char path[2048];

	if (strlen(param)==0 || hand.checkpath(uarr,msg_buf,nr,param,path)) 
		return 1;

	if (path[strlen(path)-1]=='/') 
		path[strlen(path)-1]=0;

#ifdef DEBUG
	cout <<"Removing file "<<path << endl;
#endif

	return unlink(path);

	return 0;
}
int Handler::do_rnfr(UserManager **uarr,pthread_mutex_t mutex,char* msg_buf,int nr,char *param)
{
	Handler hand;
	char path[2048];

	if (strlen(param)==0 || hand.checkpath(uarr,msg_buf,nr,param,path))
		return 1;

	if (path[strlen(path)-1]=='/') 
		path[strlen(path)-1]=0;

	// client에게 newname을 달라고요청한다
	// 그게 reto을 사용

	hand.user_return(uarr,mutex,msg_buf,nr,RET_350);

#ifdef DEBUG
	cout <<"Removing file "<<path << endl;
#endif
	return 0;

}
int Handler::do_rnto(UserManager **uarr,pthread_mutex_t mutex,char* msg_buf,int nr,char *oldname ,char *newname)
{

	cout <<"oldname : "<<oldname<<endl;
	cout <<"newname : "<<newname<<endl;

	int return_value= rename(oldname,newname);
	cout << return_value <<endl;

	return 0;
}

void Handler::handle_suspects(UserManager **uarr,pthread_mutex_t mutex,char* msg_buf,int nr)
{	
	Handler hand;
	hand.user_return(uarr,mutex,msg_buf,nr,RET_422);
	hand.kill_connection(uarr,msg_buf,nr);

}
void Handler::handle_timeout(UserManager **uarr,pthread_mutex_t mutex,char* msg_buf,int nr)
{   
	Handler hand;
	hand.user_return(uarr,mutex,msg_buf,nr,RET_423);
	hand.kill_connection(uarr,msg_buf,nr);
}

