/**
		@file 	handler.h
		@date	2009/07/24
		@author	최영업(cyu0070@naver.com) Terapi
		@brief
*/
#ifndef __HANDLER_H_
#define __HANDLER_H_

using namespace std;
#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <sys/stat.h>
#include <string.h>
#include <sys/types.h>
#include <time.h>
#include <sys/time.h>
#include <iostream>
#include "usercommand.h"
#include "usermanager.h"
#include "listener.h"
#include "servermanager.h"

#define DEBUG_HANDLER

#define RET_150  0 // 긍정적 준비 응답메시지 메시지,파일시스템,업로드 다운로드,list 
#define RET_501  1 // 명령어 수행 실패 응답 메시지 ,구문 ,
#define RET_226  2 // 긍정적 완료응답 메시지   ,연결 ,
#define RET_221  3 // 긍정적 완료 응답 메시지  ,연결  ,quit
#define RET_425  4 // 일시적 부정적인 완료응답 메시지  ,연결 ,
#define RET_428  5 // 일시적 부정적인 완료응답 메시지,연결 ,
#define RET_429  6 // 일시적 부정적인 완료응답 메시지,연결 ,
#define RET_530  7 // 명령어 완료응답 메시지   ,인증및 계정 ,
#define RET_220  8 // 긍정적 완료 응답 메시지  ,연결 ,클라이언트가 서버에 접속하는상태 
#define RET_331  9 // 긍정적 중간완료 응답 메시지, 인증 및 계정 , Pass
#define RET_531 10 // 명령어 수행 실패 메시지  ,인증 및 계정정보
#define RET_532 11 // 부정적인메시지, 인증및 계정정보
#define RET_533 12 // 부정적인메시지, 인증및 계정정보
#define RET_534 13 // 부정적인메시지, 인증및 계정정보
#define RET_422 14 // 일시적 부정적인 완료응답 메시지다시시도요청 ,연결 ,
#define RET_423 15 // 일시적 부정적인 완료응답 메시지다시시도요청 ,연결 ,
#define RET_215 16 // 긍정적인 응답완료 메시지,정보,SYST
#define RET_500 17 // 부정적 메시지,구문,로그인시
#define RET_502 18 // 부정적 메시지,구문,로그인시
#define RET_200 19 // 긍정적 완료 응답 메시지,정보, PORT설정
#define RET_250 20 // 긍정적 완료 응답 메시지 ,파일시스템, pwd
#define RET_553 21 // 부정적 메시지 ,파일시스템
#define RET_350 22 // 긍정적 중간 완료 응답 메시지,파일시스템
#define RET_451 23 // 일시적 부정적인 완료 응답 메시지다시시도요청 ,파일시스템
#define RET_209 24 // 긍적적 응답 완료 메시지, 구문,
#define RET_503 25 // 부정적 메시지,구문,로그인시
#define RET_227 26 // 긍정적 응답 완료 메시지, 연결,
#define RET_591 27 // 부정적인 메시지
#define RET_491 28 // 일시적인 부정적 응답 메시지 다시시도요청
#define RET_257 29 // 긍정적완료응답메시지, 파일시스템
#define RET_258 30 // 긍정적완료응답메시지, 파일시스템
#define RET_259 31 // 긍정적완료응답메시지, 파일시스템
#define RET_540 32 // 부정적인메시지, 규정안됨
#define RET_550 33 // 부정적인메시지, 파일시스템


#define TRFMSG_INTERVAL 1000000
#define FORMAT_LONG  0
#define FORMAT_SHORT 1
#define FORMAT_HTML  2

class UserManager;
class Handler{
	public:

		static bool first_connect_userid;
		static bool first_connect_passwd;
		static bool anonymous_login;
		int  waitaccept (UserManager**, int); ///< 로긴후 접속시간을 감시하는 함수
		void user_return(UserManager**,pthread_mutex_t, char*, int, int ); ///< 클라이언트의 행동에 따라 리퀘스트 명령어를 write하는 함수
		void user_return_only(UserManager**, int, int ); ///< 클라이언트의 행동에 따라 리퀘스트 명령어를 write하는 함수
		void user_return_addmsg(UserManager**,pthread_mutex_t, char*, char*, int, int ); ///< 클라이언트의 행동에 따라 리퀘스트 명령어를 write하는 함수
		int  user_spool (UserManager**, char*, int, int, char *);
		int  checkpath  (UserManager**,	char*, int, char*, char*); ///< 클라이언트의 명령어가 path를 변경하는 명령어면 이 명령어가 맞는 지 아닌지 확인하는 함수
		void do_list    (UserManager**,pthread_mutex_t, char*,int, char*, int); ///< 서버내의 디렉토리 리스트를 확인하는 함수
		int  do_chdir   (UserManager**,char*, int, char*); ///< 클라이언트를 위하여 클라이언트 의 현 디렉토리를 변경하는 함수
		int  do_retr(UserManager**,char*, int, char*); ///< 클라이언트에서 파일을 다운로드 해갈때 사용하는함수
		int  do_stor(UserManager**, pthread_mutex_t,char*, int, char*); ///< 클라이언트에서 파일을 업로드 해갈때 사용하는 함수
		int  do_user (UserManager**, pthread_mutex_t, char*, int, char*); ///< 클라이언트에서 아이디를 입력할때 확인하는 함수
		void do_pass (UserManager**, pthread_mutex_t, char*, int, char*); ///< 클라이언트에서 패스워드를 입력할때 확인하는 함수
		void do_size (UserManager**, pthread_mutex_t, char*, int, char*); ///< 클라이언트에서 SIZE명령어를 입력시에 처리해주는 함수
		void do_mdtm (UserManager**, pthread_mutex_t, char*, int, char*); ///< 클라이언트에서 MDTM명령어를 입력시에 파일의 마지막 변경시간을 출력처리해주는 함수
		void do_pasv (UserManager**, pthread_mutex_t, char*, int); ///< 포트를 임의로 변경해주는 함수
		int  do_rmdir(UserManager**, char*, int, char*); ///< 클라이언트에서 임의 디렉토리을 삭제명령어가 오면 이를 처리해주는 함수
		int  do_mkdir(UserManager**, char*, int, char*); ///< 클라이언트에서 임의 디렉토리을 생성명령어가 오면 이를 처리해주는 함수
		int  do_dele (UserManager**, char*, int, char*); ///< 클라이언트에서 임의 파일을 삭제명령어가 오면 이를 처리해주는 함수
		int  do_rnfr (UserManager**, pthread_mutex_t, char*, int, char *); ///< 클라이언트에서 파일명 변경 명령어가 오면 어떤 파일을 변경할것인지 from에 대한 함수
		int  do_rnto (UserManager**, pthread_mutex_t, char*, int, char *,char*); ///< 위의 명령어를 받고 이후 어떤 이름으로 변경할것인지를 받는 함수
		void handle_suspects(UserManager**,pthread_mutex_t, char*, int); ///< 아이디패스위드및 잘못된 연산에 대해서 유저의 접속을 끊는 함수
		void kill_connection(UserManager**, char*, int); ///< 위 상황이 일어났을시에 해당 클라이언트의 정보를 포함하고있는 변수를 초기화하는 함수
		void handle_timeout (UserManager**,pthread_mutex_t, char*, int); ///< 패스워드를 입력시에 클라이언트의 접속시간을 체크하는 함수 
		void User_Check_Timeout(UserManager** ,char*); ///< 정상접속후에 클라이언트의 행동이 없을때만 채크하여 이를 처리하는 함수
};

int list_match(char *,char *);
unsigned char *getmyip(int );
int list_match(char *,char *); 
int guess_star(char *,char *);
int newlist(UserManager **,char* ,int ,int ,int ,char *,char *, int callback(UserManager**,char*,int,int,char *));

#endif
