/**
		@file 	listener.cpp
		@date	2009/08/10
		@author	최영업(cyu0070@naver.com) Terapi
		@brief	클라이언트에서 들어온 명령어를 루프를 돌며 확인하여 이를 처리하는 파일
*/
using namespace std;

#include "listener.h"
#define DEBUG_LISTENER
int Listener::listen_loop(UserManager *uarr[],pthread_mutex_t mutex,char* msg_buf,int nr)	///< 접속자 수마다 루프를 돌며 명령어및 클라이언트의 행동을감시하는함수
{
	Handler hand;
	UserCommand uc;
	char temp_buffer[1024];
	char add_buf[1024];
	char sbuffer[1024];
	char buffer[1024];
	int size,r,i,j;
	char *param;
	
	for(int a=0;a<1024;a++)
	{
		temp_buffer[a]=NULL;
	}

	size=read(uarr[nr]->sock,temp_buffer,1024);


	if(temp_buffer[0]==0 &&temp_buffer[1]==0 &&temp_buffer[2]==0 &&temp_buffer[3]==0 )
	{
		uarr[nr]->sock =0;
		return 0;
	}

	for(int t=0 ; t<1024; t++)
	{
		buffer[t]=NULL;
	}

	for(int t =0; temp_buffer[t+1]!=0; t++)
		buffer[t] = temp_buffer[t];


	param=strchr(buffer,' ');
	
	
	if (param) 
	{
		*param=0;
		param++;
	}
	for (r=0;r<strlen(buffer);r++)
		buffer[r]=toupper(buffer[r]);



	for (r=0;r<REQ_COUNT;r++)
	{	
		if (!strcmp(buffer,uc.request[r])) 
			break;
	}



/*	printf("%d.%d.%d.%d",
			uarr[nr]->userip[0],uarr[nr]->userip[1],
			uarr[nr]->userip[2],uarr[nr]->userip[3]
		  );
*/	
//	fser.itoa(uarr



	
	if (uarr[nr]->state==USR_ONLINE) 
	{

	//	cout <<"r => " << r << "   " << uc.request[r] <<endl;
		switch (r) 
		{
			case REQ_SYST: ///<	server system의 OS type 출력	
				strcpy(add_buf,"SYST\n");
				usleep(500);
				uarr[nr]->resume=0;
				hand.user_return_addmsg(uarr,mutex,msg_buf,add_buf,nr,RET_215);
				break;


			case REQ_QUIT: ///<session 마침
				strcpy(msg_buf,"QUIT\n");
				usleep(500);
				hand.user_spool(uarr,msg_buf,nr,221,Conf::sByeMsgFile);
				hand.user_return(uarr,mutex,msg_buf,nr,RET_221);
				hand.kill_connection(uarr,msg_buf,nr);
				break;


			case REQ_TYPE: ///<data transfer type 지정
				strcpy(msg_buf,"TYPE\n");
				usleep(500);
				uarr[nr]->resume=0;
				if (param)
					param[0]=toupper(param[0]);
				if (param==NULL || (strcmp(param,"I") && strcmp(param,"A")))
				{
					hand.user_return(uarr,mutex,msg_buf,nr,RET_500);
					break;
				}
				sprintf(sbuffer,"200 Type set to %s.\r\n",param);
				write(uarr[nr]->sock,sbuffer,strlen(sbuffer));
				break;
			case REQ_PORT: ///< data connection port를 지정 
				if (uarr[nr]->pasvsock) 
				{
					close(uarr[nr]->pasvsock);
					uarr[nr]->pasvsock=0;
				}
				uarr[nr]->resume=0;
				if ((sscanf(param,"%d,%d,%d,%d,%d,%d", &uarr[nr]->dataip[0],&uarr[nr]->dataip[1], &uarr[nr]->dataip[2], &uarr[nr]->dataip[3],&i,&j))<6)
				{
					uarr[nr]->dataport=0;
					hand.user_return(uarr,mutex,msg_buf,nr,RET_502);
					break;
				}
				uarr[nr]->dataport=((i&0xFF)<<8)|(j&0xFF);
				pthread_mutex_lock(&mutex);
				strcpy(add_buf,"PORT ");
				strcat(add_buf,param);
				pthread_mutex_unlock(&mutex);
/*
				write(uarr[nr]->sock,uc.ftp_returnstr[RET_200],strlen(uc.ftp_returnstr[RET_200]));
				strcpy(t_buf, add_buf);
				strcat(t_buf, uc.ftp_returnstr[RET_200]);
				strcpy(msg_buf,	t_buf );
*/
				hand.user_return_addmsg(uarr,mutex,msg_buf,add_buf,nr,RET_200);
				sleep(1);

				break;



			case REQ_APPE:	///< 이어보내기
				strcpy(msg_buf,"APPE\n");
				usleep(500);
				cout << " REQ_APPE "<< endl;
				if(param)
				{
					cout <<"param" << param<<endl;
				}
				break;



			case REQ_LIST: ///< directory의 file list 출력 (``ls -lgA'')

				uarr[nr]->resume=1;
				if (param) 
				{
					param[512]=0;
					strcpy(sbuffer,param);
				} 
				else
					strcpy(sbuffer,"*");
				if ((uarr[nr]->pid=fork())==0) 
					hand.do_list(uarr,mutex,msg_buf,nr,sbuffer,FORMAT_LONG);
				uarr[nr]->idletime=time(NULL); // keep alive 
				break;

			case REQ_NLST: ///< directory의 file list name만 보여준다
				strcpy(msg_buf,"NLST\n");
				usleep(500);
				uarr[nr]->resume=0;
				if (uarr[nr]->pid) 
				{
					hand.user_return(uarr,mutex,msg_buf,nr,RET_491);
					break;
				}

				if (param) 
				{
					param[512]=0;
					strcpy(sbuffer,param);
				}
				else
					strcpy(sbuffer,"*");

				if ((uarr[nr]->pid=fork())==0)
					hand.do_list(uarr,mutex,msg_buf,nr,sbuffer,FORMAT_SHORT);
				uarr[nr]->idletime=time(NULL); // keep alive 
				break;
			case REQ_CDUP: ///< 현재 작업 directory를 부모 directory로 이동
				strcpy(msg_buf,"CDUP\n");
				usleep(500);

				strcpy(buffer,"..");
				param=buffer;            // break through !!! 
			case REQ_CWD: ///< 작업 directory를 이동 
				strcpy(msg_buf,"CWD\n");
				usleep(500);
				uarr[nr]->resume=0;
				if (param) 
					param[512]=0;

				printf("1.1 msg_buf [%s] \n",msg_buf);
				printf("1.2 param   [%s] \n",param);

				if (hand.do_chdir(uarr,msg_buf,nr,param)) 
				{
					sprintf(sbuffer,"550 %s: No such directory.\r\n",param);
					write(uarr[nr]->sock,sbuffer,strlen(sbuffer));
				} 
				else
					hand.user_return(uarr,mutex,msg_buf,nr,RET_250);
				break;
			case REQ_PWD: ///< directory 제거
				strcpy(msg_buf,"PWD\n");
				usleep(500);
				uarr[nr]->resume=0;
				sprintf(sbuffer,"257 \"%s\" is current directory.\r\n",uarr[nr]->reldir);
				write(uarr[nr]->sock,sbuffer,strlen(sbuffer));
				break;
			case REQ_RETR: ///< file 정정
//				strcpy(msg_buf,"RETR\n");
//				usleep(500);
				/*			if (uarr[nr]->pid) 
							{
							hand.user_return(uarr,mutex,msg_buf,nr,RET_491);
							break;
							}
							*/
				/*			if (conf.logfile!=NULL && param!=NULL) 
							{
							param[512]=0;
							tm=time(NULL);
							strcpy(sbuffer,ctime(&tm));
							sbuffer[strlen(sbuffer)-1]=0;
							fprintf(conf.logfile,"%s: RETR: user %d, %s by %s (%d.%d.%d.%d)\n",
							sbuffer,nr+1,param,uarr[nr]->url, uarr[nr]->userip[0],uarr[nr]->userip[1], uarr[nr]->userip[2],uarr[nr]->userip[3]);	
							fflush(conf.logfile);
							}
							*/
				uarr[nr]->pid=fork();

				if (uarr[nr]->pid==0) 
				{
					hand.user_return(uarr,mutex,msg_buf,nr,hand.do_retr(uarr,msg_buf,nr,param));
					exit(0);
				}

				uarr[nr]->resume=0;
				break;
			case REQ_REST: ///< 불완전한 전송을 재시도
				strcpy(msg_buf,"REST\n");
				usleep(500);
				param[32]=0; // this should be enough 
				j=0;
				i=sscanf(param,"%d",&j);
				if (i>0 && j>=0) 
				{
					hand.user_return(uarr,mutex,msg_buf,nr,RET_350);
					uarr[nr]->resume=j;
				}
				else
					hand.user_return(uarr,mutex,msg_buf,nr,RET_501);
				break;
			case REQ_SIZE: ///< file size 출력
				strcpy(msg_buf,"SIZE\n");
				usleep(500);
				uarr[nr]->resume=0;
				if (param)
					param[512]=0;
				hand.do_size(uarr,mutex,msg_buf,nr,param);
				break;
			case REQ_MDTM: ///<	file의 마지막 변경시간 출력
				strcpy(msg_buf,"\n");
				usleep(500);
				uarr[nr]->resume=0;
				if (param) 
					param[512]=0;
				hand.do_mdtm(uarr,mutex,msg_buf, nr,param);
				break;
			case REQ_STOR: ///< file 저장
				strcpy(msg_buf,"\n");
				usleep(500);

				if (uarr[nr]->pid) 
				{
					hand.user_return(uarr,mutex,msg_buf,nr,RET_491);
					break;
				}

				/*			if (logfile!=NULL && param!=NULL) 
							{
							param[512]=0;
							tm=time(NULL);
							strcpy(sbuffer,ctime(&tm));
							sbuffer[strlen(sbuffer)-1]=0;

							fprintf(logfile,"%s: STOR: user %d, %s by %s (%d.%d.%d.%d)\n",
							sbuffer,nr+1,param,uarr[nr]->url,
							uarr[nr]->userip[0],uarr[nr]->userip[1],uarr[nr]->userip[2],uarr[nr]->userip[3]);
							fflush(logfile);
							}
							*/
				if (uarr[nr]->perm & PERM_UPLOAD) 
				{
					uarr[nr]->pid=fork();

					if (uarr[nr]->pid==0) 
					{
						if (param) param[512]=0;
						switch (hand.do_stor(uarr,mutex,msg_buf,nr,param)) 
						{
							case 1:
								hand.user_return(uarr,mutex,msg_buf,nr,RET_501);
								break;
							case 2:
								hand.user_return(uarr,mutex,msg_buf,nr,RET_553);
								break;
		/*					case 3:
								hand.user_return(uarr,mutex,msg_buf,nr,RET_451);
								if (logfile!=NULL) 
								{
									fprintf(logfile,"ERROR: Sending %s from user %d.",param,nr+1);
									fflush(logfile);
								}
								break;
		*/					default:
								hand.user_return(uarr,mutex,msg_buf,nr,RET_226);
		/*						if (logfile!=NULL) 
								{
									fprintf(logfile,"COMPLETE: Sending %s from user %d.",param,nr+1);
									fflush(logfile);
								}
		*/						break;
						}

						exit(0);
					}
				}
				else
					hand.user_return(uarr,mutex,msg_buf,nr,RET_553);
				uarr[nr]->resume=0;
				break;
			case REQ_NOOP: ///< do nothing
				strcpy(msg_buf,"\n");
				usleep(500);
				sprintf(sbuffer,"200 OK.\r\n");
				write(uarr[nr]->sock,sbuffer,strlen(sbuffer));
				break;
			case REQ_PASV: ///< server와 server간은 전송 비교
				strcpy(msg_buf,"PORT \n");
				usleep(500);
				hand.do_pasv(uarr,mutex,msg_buf,nr);
				break;
			case REQ_ABOR: ///< 이전명령중지
				strcpy(msg_buf,"\n");
				usleep(500);
				if (uarr[nr]->pid) kill(uarr[nr]->pid,SIGTERM);
				uarr[nr]->pid=0;
				if (uarr[nr]->pasvsock) 
				{
					close(uarr[nr]->pasvsock);
					uarr[nr]->pasvsock=0;
				}
				hand.user_return(uarr,mutex,msg_buf,nr,RET_227);
				break;
			case REQ_MKD: ///< 디렉토리생성
				strcpy(msg_buf,"\n");
				usleep(500);
				/*			if (uarr[nr]->perm & PERM_UPLOAD) 
							{
							*/				if (param) 
				{
					if (!hand.do_mkdir(uarr,msg_buf,nr,param))
						hand.user_return(uarr,mutex,msg_buf,nr,RET_257);
					else 
						hand.user_return(uarr,mutex,msg_buf,nr,RET_553);
				} 
				else
					hand.user_return(uarr,mutex,msg_buf,nr,RET_501);
				//			}
				//			else
				//				hand.user_return(uarr,mutex,msg_buf,nr,RET_553);
				break;
			case REQ_RMD: ///< directory 제거 
				strcpy(msg_buf,"\n");
				usleep(500);
				if (uarr[nr]->perm & PERM_ERASE) 
				{
					if (param) 
					{
						if (!hand.do_rmdir(uarr,msg_buf,nr,param))
							hand.user_return(uarr,mutex,msg_buf,nr,RET_258);
						else 
							hand.user_return(uarr,mutex,msg_buf,nr,RET_553);
					} 
					else
						hand.user_return(uarr,mutex,msg_buf,nr,RET_501);
				} 
				else
					hand.user_return(uarr,mutex,msg_buf,nr,RET_553);
				break;
			case REQ_DELE: ///< file 삭제
//				strcpy(msg_buf,"\n");
//				usleep(500);
				//			if (uarr[nr]->perm & PERM_ERASE) 
				//			{
				if (param) 
				{
					param[512]=0;
					if (strchr(param,' '))
						*strchr(param,' ')=0;
					if (!hand.do_dele(uarr,msg_buf,nr,param)) 
						hand.user_return(uarr,mutex,msg_buf,nr,RET_259);
					else hand.user_return(uarr,mutex,msg_buf,nr,RET_501);
				} 
				else 
					hand.handle_suspects(uarr,mutex,msg_buf,nr);
				//			} 
				//			else
				//				hand.user_return(uarr,mutex,msg_buf,nr,RET_553);
				break;

			case REQ_RNFR: ///< 파일명 변경
				strcpy(msg_buf,"\n");
				usleep(500);
				if (param)
				{
					if(!hand.do_rnfr(uarr,mutex,msg_buf,nr,param));

					char buffer[1024],temp_buffer[1024];
					size=recv(uarr[nr]->sock,temp_buffer,sizeof(temp_buffer),0);

					for(int tt=0 ; tt<1024; tt++)
						buffer[tt]=NULL;


					for(int tt =0;temp_buffer[tt]!=13 || temp_buffer[tt+1]!=10; tt++)
				{
					buffer[tt] = temp_buffer[tt];
				}
				
				char *param2=strchr(buffer,' ');

				if (param2) 
				{
					*param2=0;
					param2++;
				}
				for (r=0;r<4;r++)
					buffer[r]=toupper(buffer[r]);


				for(int a=0; a<5; a++)
				{
					printf("%d %c\n",a,buffer[a]);
				}

				hand.do_rnto(uarr,mutex,msg_buf,nr,param,param2);

			}
		default:
			if ((unsigned char)buffer[0]>0x7F) 
			{
				hand.user_return(uarr,mutex,msg_buf,nr,RET_209);
				hand.kill_connection(uarr,msg_buf,nr);
				break;
			}
			uarr[nr]->resume=0;
			hand.user_return(uarr,mutex,msg_buf,nr,RET_503);
			break;
		}
	} 
	else 
	{
		switch (r) 
		{
			case REQ_USER:
				{
					if (param) 
					{
						param[512]=0;
						if (strchr(param,'\n')) 
							*strchr(param,'\n')=0;
						param = &param[0];
						hand.do_user(uarr,mutex,msg_buf,nr,param);
					} 
					else
						hand.handle_suspects(uarr,mutex,msg_buf,nr);
					break;
				}
			case REQ_PASS:
				{
					if (param && uarr[nr]->state==USR_PASS)
					{
						param[512]=0;
						hand.do_pass(uarr,mutex,msg_buf,nr,param);
					} 
					else
						hand.handle_suspects(uarr,mutex,msg_buf,nr);
					break;
				}
			case REQ_GET:
				sprintf(sbuffer,"<HTML><HEAD><TITLE>HTTP-access denied</TITLE></HEAD><BODY><H1>HTTP-access denied.</H1><HR>This is <B>NOT</B> a http-server. Try using \"ftp://'user':'passwd'@'url'/\".</BODY></HTML>\r\n");
				write(uarr[nr]->sock,sbuffer,strlen(sbuffer));
				hand.kill_connection(uarr,msg_buf,nr);
				break;
			default:
				hand.handle_suspects(uarr,mutex,msg_buf,nr);
				break;
		}
	}
pthread_mutex_lock(&mutex);  
	return 0;
}


