/**
		@file 	usermanager.h
		@date   2009/08/13	
		@author	최영업(cyu0070@naver.com) Terapi
		@brief
*/
#ifndef __USERMANAGER_H_
#define __USERMANAGER_H_

using namespace std;

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <netdb.h>
#include <netinet/in.h>
#include <iostream>


#include "config.h"
#include "handler.h"
#define DEFAULT_USERINFOPATH "/etc/denftpserver/userinfo.ini"
/**
		@class		UserManager
		@date		2009/08/14		
		@author		최영업
		@brief		client접속시에 생성되어야할 UserManager_class
		@warning 
 */
class UserManager
{ 
	friend class User;
	public:
		static int s_Cur_User_Count; ///< 현재 접속중인 사용자수
		
		UserManager();
		UserManager(int, int, int, int , int,
				    int, int, unsigned short int ,int,
 					int*,int*,char*,char * ,
					char*
				);
		
		
		~UserManager();
//private:
public:
		int  sock;		///< User마다 고유한 번호를 지정하기 위하여 select함수에서지정된고유번호
		int  idletime;	///< client의 사용시간
		int  usertype;	///< user의 타입정보
		int  pid;		///< processid
		int  resume;
		int  state;
		int  perm;
		unsigned short int dataport;
		int  pasvsock;
		int  *userip;
		int  *dataip;
		char * rootdir;
		char * reldir;
		char * url;			///< url
}; 

class LoginInfo
{
	public:
		static char s_username[5]; ///< UserID
		static char s_passwd[5];	///< UserPassWord
		static char s_root[10]; ///< 로긴시에 접속가능한 디렉토리
		static int  s_maxlogins;	///< 접속가능한 인원수
		static int s_perm; ///<user 허가권

		int  m_ReadUserInfo(char *); ///<userinfo파일을 읽어드리는 함수
		int  m_Optindex(char *opt); ///<Userinfo파일을 읽어드린후 정보를 받을시에 해당문자가 무엇인지 확인하는 함수
		int  m_Add_User(char *,char *); ///< ini파일에 있는 user정보를 읽어 logininfo class에 저장하는 함수
	
		LoginInfo(){};
};
#endif

